define(['views/accountListView'], function (View) {
	 var que,
        isOpenNew,
        sle;
       var isNew = 1,//新开
        isGua = 2;//下挂
	var bindings = [{
		element: '.select-all',
		event: 'click',
		handler: selectAllRouter
	}, {
		element: '#accountList input[type="checkbox"]',
		event: 'change',
		handler: syncSelect
	},{
        element: '#leftback',
        event: 'click',
        handler: setOpen
    }];
	var hide_button = "";
	function init(query) {
		var valueString = decodeURI(query.value);
		var title = query.title;
		var values = valueString.split(' ');
		var selected = query.selected;
		//需要隐藏新开下挂按钮的类型
		hide_button = query.hide_button;
		
		que = query;
        isOpenNew = query.isOpen.split(',');
        console.info(isOpenNew);
		View.renderTitle(title);
		$$.ajax({
			url: '/getAccountInfo.do?rnd=' + new Date().getTime(),
			type: 'GET',
			data: {title: title},
			success: function (data) {
				data = JSON.parse(data);
				if (data.errorNo === 0) {
					View.render({
						model: data,
						bindings: bindings
					});
					if(isOpenNew.length <= 1){
                        setDefault(isOpenNew);
                        console.log('setDefault');
                    }
                    console.log(isOpenNew);
                    syncIsOpenNew();
					if(selected === "0"){
						$$('#accountList input[type="checkbox"]').each(function () {
							if (values.indexOf(this.value) !== -1) {
								this.checked = true;
								$$(this).trigger('change');
							}
						});
					}else{
						selectAll();
					}
					showStatus();
				}
			}
		});
	}
	
	function setDefault(el,callback) {
        var options = $$('#accountList input[type="checkbox"]'),
            source,
            value;
        options.each(function () {
            source = $$('#signContent input[name="' + this.name + '"]');
            value = parseInt(this.value);
            //console.log(this.value);
            switch (value) {
                case 1:
                    el[value] = isNew;
                    break;
                case 2:
                    el[value] = isGua;
                    break;
            }
        });
        if(typeof callback === 'function'){
            callback();
        }
    }
    
    function syncIsOpenNew(){
        $$('#accountList input[type="checkbox"]').each(function(){
           var buttons = $$(this).parent().find('.button');
            $$(buttons).removeClass('color-gray');
            if(isOpenNew[this.value] == isNew){
                $$(buttons[1]).addClass('color-gray');
            }else {
                $$(buttons[0]).addClass('color-gray');
            }
			if(!isOpenNew[1] && this.value == isNew){
				$$(buttons[1]).addClass('color-gray');
				$$(buttons[0]).removeClass('color-gray');
				isOpenNew[this.value] = isNew;
			}
			if(!isOpenNew[2] && this.value == isGua){
				isOpenNew[this.value] = isGua;
			}
			if(!isOpenNew[11] && this.value == 11){
				isOpenNew[this.value] = isGua;
			}
			if(!isOpenNew[21] && this.value == 21){
				isOpenNew[this.value] = isGua;
			}
        });
    }
    

	function isAllSelected(){
		var options = $$('#accountList input[type="checkbox"]');
		var source = true;
		options.each(function(){
			if(this.checked != true){
				source = false; //未全选
				return source;
			}
		});
		return source;
	}
	
	//初始化全选按钮状态
    function showStatus(){
        if(isAllSelected()){
            $$(".select-all").html('<span>全不选</span>');
        }
        else {
            $$(".select-all").html('<span>全选</span>');
        }
    }
	
	function selectAllRouter(){
		//如果已全选
		if(isAllSelected()){
			rejectAll();
			$$(".select-all").html('<span>全选</span>');
		}
		//未全选
		else{
			selectAll();
			$$(".select-all").html('<span>全不选</span>');
		}
	}
	//全选按钮
	function selectAll() {
		var options = $$('#accountList input[type="checkbox"]'),
			values = [],
			source,
			finalValue;

		options.each(function () {
			source = $$('#signContent input[name="' + this.name + '"]');
			if(!this.checked){
				this.checked = true;
				$$(this).trigger("change");
			}
			values.push(this.value);
			finalValue = values.join(' ');
			source.val(finalValue);
			source[0].checked = finalValue.length === 0 ? false : true;

			//已经选好的，直接赋值
			if(isOpenNew[this.value]){
				isOpenNew[this.value] = isOpenNew[this.value];
			}else if(this.value == 1 && !isOpenNew[this.value]){
				//默认给上海A股赋值新开
				isOpenNew[this.value] = 1;
				$$($$(".item-after").eq(0).children().eq(0)).removeClass("color-gray");
				$$($$(".item-after").eq(0).children().eq(1)).addClass("color-gray");
			}else if(this.value == 2 && !isOpenNew[this.value]){
				//默认给深圳A股赋值下挂
				isOpenNew[this.value] = 2;
				$$($$(".item-after").eq(1).children().eq(0)).addClass("color-gray");
				$$($$(".item-after").eq(1).children().eq(1)).removeClass("color-gray");
			}else if(this.value == 11){
				isOpenNew[this.value] = 2;
			}else if(this.value == 21){
				isOpenNew[this.value] = 2;
			}


		});
		setOpen();
		displayCommission();
	}
	//全不选
	function rejectAll(){
		var options = $$('#accountList input[type="checkbox"]'),
			values = [],
			source,
			finalValue;
		options.each(function () {
			source = $$('#signContent input[name="' + this.name + '"]');
			if(this.checked){
				this.checked = false;
				$$(this).trigger("change");
			}
			values.push(this.value);
			finalValue = values.join(' ');
			source.val('');
			source[0].checked = finalValue.length === 0 ? true : false;
			for(var i=0;i<isOpenNew.length;i++){
				isOpenNew[this.value] = "";
				$$(".open").addClass("color-gray");
				$$(".under").addClass("color-gray")
			}
		});
		setOpen();
		displayCommission();
	}
	

//	function syncSelect() {
//		var source = $$('#signContent input[name="' + this.name + '"]'),
//			target = this,
//			value = this.value,
//			finalValue;
//
//		source.each(function () {
//			target.checked ? add(this, value) : remove(this, value);
//
//			finalValue = this.value;
//			this.checked = finalValue.length === 0 ? false : true;
//		});
//	}
	 function syncSelect() {
		 var hide_buttonArray = new Array();
		 hide_buttonArray = hide_button.split(',');
		 
		 showStatus();
        var source = $$('#signContent input[name="' + this.name + '"]'),
            target = this,
            value = this.value,
            finalValue;
        sle = this.name;
        if (this.checked) {
        	$$(this).parent().find('.item-after').css('visibility', 'visible');
			var buttons = $$(this).parent().find('.item-after .button');
        	//场内基金默认为下挂，隐藏新开下挂按钮
        	for(var i=0;i<hide_buttonArray.length;i++){
        		if(hide_buttonArray[i] == this.value){
        			 $$(this).parent().find('.item-after').css('visibility', 'hidden');
        		}
        	}
        	

            $$(buttons).each(function (index, el) {
                $$(el).click(function (e) {
                    e.stopPropagation();
                    e.preventDefault();
                    $$(this).parent().find('.button').addClass('color-gray');
                    $$(this).removeClass('color-gray');
                    value = parseInt(value);
                    console.log(index);
                    if(index === 0){
                        isOpenNew[value] = isNew;
                    }else{
                        isOpenNew[value] = isGua;
                    }
                });

            })
        } else {
            $$(this).parent().find('.item-after').css('visibility', 'hidden');
        }
	 	source.each(function () {
            target.checked ? add(this, value) : remove(this, value);

            finalValue = this.value;
            this.checked = finalValue.length !== 0;
        });
        setOpen();
	 }
	 
	  function setOpen(){
		  isOpenNew[11] = 2;
		  isOpenNew[21] = 2;
        var openString = isOpenNew.join(',');
        //console.log(openString);
        var source = $$('#signContent input[name="' + sle + '"]');
        //console.log(source,$$(source).attr('data-open'),openString);
        $$(source).attr('data-open','');
        $$(source).attr('data-open',openString);

    }
    
	function add(target, value) {
		if (typeof target.value === 'undefined') return;

		if (target.value.length === 0) {
			$$(target).val(value);
		} else {
			var values = target.value.split(' ');

			if (values.indexOf(value) === -1) {
				values.push(value);
			}

			$$(target).val(values.join(' '));
		}
        displayCommission();
	}

	function remove(target, value) {
		var values = target.value.split(' ');

		if (values.indexOf(value) !== -1) {
			if (values.length === 1) {
				$$(target).val('');
			} else {
				var valueReverse = [];
				values.map(function (v, i) {
					if (v !== value) {
						valueReverse.push(v);
					}
				});
				$$(target).val(valueReverse.join(' '));
			}
		}
		 displayCommission();
	}

 /**
	 * 是否显示佣金
     */
	function displayCommission() {
        var arr = $$("input[name=accountStock]").val().split(" ");
        var flag = "0";
        for(var i=0; i<arr.length; i++){
        	if(arr[i] == "1" || arr[i] == "2"){
                flag = "1";
                break;
			} else if(arr[i] == "11" || arr[i] == "21"){
        		flag = "2";
			}
        }
        if(flag == "1"){
            $$(".stockCommission").show();
            $$(".fundCommission").hide();
        }else if(flag == "2"){
        	$$(".stockCommission").hide();
        	$$(".fundCommission").show();
		}else if(flag == "0"){
            $$(".stockCommission").hide();
            $$(".fundCommission").hide();
		}

    }

	return {
		init: init
	};
});
