define(['views/bankView','GS'], function (View,GS) {
	
	var APP_bank = {};
	APP_bank.sn = "";
	APP_bank.isReBind = "";
	var bindings = [];

	function init() {
			$$.ajax({
				url: '/listBank.do?rnd=' + new Date().getTime(),
				type: 'POST',
				success: function (data) {
					khApp.hideIndicator();
					data = JSON.parse(data);
					if (data.errorNo === 0) {
						View.render({
							model: data.model,
							bindings: bindings
						});
						APP_bank.sn = data.model.sn;
						APP_bank.isReBind = data.model.isReBind;
					}else{
						khApp.alert(data.errorInfo);
					}
				},
				error: function() {
					khApp.hideIndicator();
		   			khApp.alert(MESSAGE_TIMEOUT);
		   		},
		   		timeout: function() {
		   			khApp.hideIndicator();
		   			khApp.alert(MESSAGE_TIMEOUT);
		   		}
			});
		//输入框加焦点
//		setTimeout(function(){$$('.mobile').focus();},500);
	}
	
	return {
		init: init
	}
});
