define(['views/depositoryView', 'GS'], function (View, GS) {
	
	var APP_thirdBank = {};
	APP_thirdBank.pre = "/returnUserProfile.do";
	APP_thirdBank.next = "/exam";
	
	APP_thirdBank.Bank = "";
	APP_thirdBank.sn="";
	APP_thirdBank.md5 = "";
	APP_thirdBank.BankCode = "";
	APP_thirdBank.accountNo = "";
	APP_thirdBank.accountPass = "";
	APP_thirdBank.accountPassRepeat = "";
	APP_thirdBank.bankType = "";
	APP_thirdBank.isReBind = "";	//0:绑定  	1：重新绑定
	APP_thirdBank.econtractId = "";
	//是否在交易时间
	APP_thirdBank.outTime = "";
	APP_thirdBank.sTime = "";
	APP_thirdBank.eTime = "";
	//工行转账
	APP_thirdBank.icbcTranCode = "";
	APP_thirdBank.icbcTran = "";
	APP_thirdBank.icbcTranType = "";
	APP_thirdBank.icbcTranMemo = "";
	//工行短信
	APP_thirdBank.icbcMessCode = "";
	APP_thirdBank.icbcMessType = "";
	APP_thirdBank.icbcMessMemo = "";
	
	var bindings = [{
		element: '#depositoryGoBack',
		event: 'click',
		handler: goBack
	},{
		element: '.depository-list a',
		event: 'click',
		handler: chooseBank
	}];

	var afterBindings = [{
		element: '#depositoryGoBack',
		event: 'click',
		handler: goBack
	},{
		element: '.depository-list a',
		event: 'click',
		handler: chooseBank
	}];

	function init() {
		//在重新绑定时，隐藏左边返回按钮
		if($$("#removeLeftButton").val()){
			$$(".left").css("visibility","hidden");
		}
		//判断是否使用CA
		if(( appParams.isUseCA == "true")){
			findSn();
		}
		khApp.showIndicator();
		$$.ajax({
			url: '/listBank.do?rnd=' + new Date().getTime(),
			type: 'POST',
			success: function (data) {
				khApp.hideIndicator();
				data = JSON.parse(data);
				
				if (data.errorNo === 0) {
					View.render({
						model: data.model,
						bindings: afterBindings
					});
					APP_thirdBank.sn = data.model.sn;
					APP_thirdBank.isReBind = $$("#isReBind").val();
					
					//工行转账
					if(data.model.icbcTran){
						APP_thirdBank.icbcTran = data.model.icbcTran;
						APP_thirdBank.icbcTranCode = data.model.icbcTran.bankCode;
						APP_thirdBank.icbcTranType = data.model.icbcTran.type;
						APP_thirdBank.icbcTranMemo = data.model.icbcTran.depository_memo;
					}
					
					//是否在交易时间
					APP_thirdBank.outTime = data.model.outTime;
					APP_thirdBank.sTime = data.model.sTime;
					APP_thirdBank.eTime = data.model.eTime;
				}else{
					khApp.alert(data.errorInfo);
				}
			},
			error: function() {
				khApp.hideIndicator();
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		},
	   		timeout: function() {
	   			khApp.hideIndicator();
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		}
		});
	}

    function chooseBank(){
    	var name = $$(this).find('.bank-name').text();
    	var type = $$(this).data('type');
    	var protocalId = $$(this).data('protocal-id');
    	var bankCode = $$(this).data('bankCode');
    	var cls = $$(this).data('cls');
    	var hint = $$(this).data('hint');
    	var memo = $$(this).data('memo');
    	var mobile = $$('#mobile').val();
    	var econtract_name = $$(this).data('econtract_name');
		var card_memo = $$(this).data('card');
		var pwd_memo = $$(this).data('pwd');

		console.info(memo);
    	mainView.loadPage('/template-3.0/depository-detail.html?name=' + name + '&type=' + type +
    			'&econtract_id=' + protocalId + '&bankCode=' + bankCode + '&isReBind='
    			+APP_thirdBank.isReBind+'&cls=' + cls+(hint ? '&hint=' + hint : '')+'&sn='+APP_thirdBank.sn
    			+'&memo='+memo+'&mobile='+mobile + '&outTime='+APP_thirdBank.outTime + 
    			'&icbcTranType='+APP_thirdBank.icbcTranType + '&icbcTranCode='+APP_thirdBank.icbcTranCode
    			+ '&icbcTranMemo='+APP_thirdBank.icbcTranMemo + '&sTime='+ APP_thirdBank.sTime + 
    			'&eTime='+APP_thirdBank.eTime+'&econtract_name='+econtract_name+'&card_memo='+card_memo
				+'&pwd_memo='+pwd_memo);
    }
	
	//返回
	function goBack() {
		mainView.loadPage(APP_thirdBank.pre);
	}
	
	return {
		init: init
	};
});
