define(['views/collectHeadView'], function (View) {

    var userId					= "";
    var userName				= "";
    var videoServer			= "";
    var videoPort				= 8906;
    var roomId					= 8906;
    var cookieDomain 		= "";//domain
    var cookiestr 				= "";//cookie
    var picUploadUrl 			= "";//upload url
    var videoUploadUrl 		= "";//upload url
    var texts						= ["","",""];
    var timer 						= null;
    var videoIsOk 				= false;
    var svideoFilePath = "";

	var bindings = [{
		element: '#uploadHead',
		event: 'click',
		handler: uploadHead
  },{
    element: '#nextbutton',
    event: 'click',
    handler: nextSubmit
	},{
		element: '#reuploadHead',
		event: 'click',
		handler: uploadHead
  }];
	
  var timer 						= null;
  var isShowExpModal = false;
  var cookiestr 				= "";//cookie
  var photoIsOk 				= false;
	function init() {
		window.parsePicUrl = parsePicUrl_svideo;
        window.finishSVideo = finishSVideo;
        window.finishIOSSVideo = finishIOSSVideo;
		cookiestr =  $$("#cookiestr").val();
		photoIsOk = false;
		View.render({
			bindings: bindings
		});
		initData();
		 $$('#uploadHead').show();
	     $$('#reuploadHead').hide();
	}

    //初始化数据
    function initData(){
        userId					= $$("#userId").val();
        userName				= $$("#userName").val();
        cookieDomain 			= $$("#cookieDomain").val();
        cookiestr 				= $$("#cookiestr").val();
        videoUploadUrl 			= $$("#videoUploadUrl").val();
        videoServer				= $$("#videoServer").val();
        videoPort				= $$("#videoPort").val()-0;//转int
    }

	function uploadHead(event) {
		uploadSelectTimer(2);
	}



	/**
	 * 上传照片类型
	 * @param  {Number} type 0: 正面照, 1: 反面照, 2: 大头照
	 */
	function uploadSelectTimer(type) {
    	timer = setTimeout(uploadSelect(2),1000);
	}
	
	 function changestatus() {
	      $$('#uploadHead').hide();
	      $$('#reuploadHead').show();
	 }

	 
  function modalExp(callback) {
    khApp.modal({
      title: '拍摄示范',
      text: '<img width="80%" src="https://sjkh.cfzq.com/template-3.0/img/modal-tip.png" alt="" />\
            <div class="collecttext">请将<span>证件平放</span>，手机<span>横向拍摄</span>。保证照片中身份证<span>边框完整</span>，字迹清晰，亮度均匀</div>\
            <div class="collectbtn">我知道了，不再提醒</div>',
    })
    $$('.collectbtn').on('click',function() {
      khApp.closeModal();
      if (callback) {
        callback();
      }
    })
  }

  /**
	 * 原版本方法
	 * @param  {Number} picType 0: 正面照, 1: 反面照,  2: 
	 */
	function uploadSelect(picType) {
		if(browser.versions.ios){	//iphone
			var picTypeStr;
			switch(picType){
				case 0:
					picTypeStr = "front";
		  			break;
				case 1:
					picTypeStr = "back";
		  			break;
		  		case 2:
		  			picTypeStr = "face";
		  			break;
				default:
					picTypeStr = "front";
			}
			window.location.href="objc://takePictures/?"+picTypeStr+"?"+cookiestr;
		}else{
			window.jtoJHandle.takePictures(picType,cookiestr);
		}
	}
	/**
	* 解析图片 url
	* @param  {Object} json
	*/
	function parsePicUrl_svideo(json){
		clearTimeout(timer);
		var obj = eval('(' + json + ')');
		var errNo = obj.errorNo;
		if (errNo === 0) {
			photoIsOk = true;
			//解析返回的图片地址url
			var url 		= obj.src;
			changestatus();
			View.showPhotoFace(url);
		} else {
			khApp.alert(obj.errorInfo);
		}
	}
	function nextSubmit() {
		if(photoIsOk){
			khApp.showIndicator();
			callback();
		} else {
			khApp.alert("头像照未上传成功，请重新拍头像照上传");
		}
	}

    function callback() {
		khApp.hideIndicator();
//		  texts[0]= "我是"+userName;
        timer = setTimeout(function(){
            texts[1]= "自愿";
            texts[2]= "在财富证券开户";
            if(browser.versions.ios){ //iphone
                texts[0]= "本人"+userName+"";
                window.location.href="objc://startSVideo/?"+userId+"?"+userName+"?"+cookieDomain+"?"+cookiestr+"?"+videoUploadUrl+"?"+texts;
            }else{
                texts[0]= "本人"+userName+",";

                jtoJHandle.startSVideo(videoServer,videoPort,roomId,userId,userName,cookieDomain,cookiestr,videoUploadUrl,texts);
            }
        },1000);
    }

    //android视频录制完成回调
    function finishSVideo(errorNo,errorInfo, videoFilePath, imageBase64){
        svideoFilePath = videoFilePath;
        if(errorNo ==0){
            khApp.showIndicator();
            mainView.loadPage("/audit?v="+new Date().getTime());
        }else{
            khApp.alert("视频上传不成功，"+errorInfo);
        }
    }

    //IOS 视频录制完成回调
    function finishIOSSVideo(json){
        var obj = JSON.parse(json);
        if(obj.errorNo ==0){
            khApp.showIndicator();
            mainView.loadPage("/audit?v="+new Date().getTime());
        }else{
            khApp.alert("视频上传不成功，"+obj.errorInfo);
        }
    }

	return {
		init: init
	};
});
