define([ 'views/protocalView', 'GS' ], function(View, GS) {
	function init(query) {
		requestContent(query);
	}
	function requestContent(query) {
		khApp.showIndicator();
		$$.ajax({
			url : '/getProtocalContent.do?rnd=' + new Date().getTime(),
			method : 'POST',
			timeout : 15000,
			data : query,
			success : function(d) {
				try {
					var data = JSON.parse(d);
					if (data.errorNo === 0) {
						View.render({
							model : data.model
						});
					}
				} catch (e) {
					_CMN.log("加载协议[" + JSON.stringify(query) + "]异常" + (e.stack || e.message || ''));
				}
				khApp.hideIndicator();
			},
			error : function() {
				_CMN.log("加载协议错误");
				khApp.alert(MESSAGE_TIMEOUT);
			},
			timeout : function() {
				_CMN.log("加载协议超时");
				khApp.alert(MESSAGE_TIMEOUT);
			}
		});
	}
	return {
		init : init
	};
});