define(['views/reformView', 'GS'], function (View, GS) {

	var bindings = [{
		element: '#reformList .card-footer',
		event: 'click',
		handler: function(){
			mainView.loadPage(this.attributes.tourl.value);
		}
	}];

	function init() {
		khApp.showIndicator();
		$$.ajax({
			url: '/getRectification.do?rnd=' + new Date().getTime(),
			type: 'POST',
			success: function (data) {
				data = JSON.parse(data);
					View.render({
						bindings: bindings,
						model: data.list
					});
					khApp.hideIndicator();
			}
		});
	}

	return {
		init: init
	};
});
