define(['utils'], function (Utils) {

	APP_video_upload               = {};
	APP_video_upload.next			= "/callback";
//	APP_video_upload.pre  			= "/returnUserProfile.do";
	APP_video_upload.userId		= "";
	APP_video_upload.cookiestr		= "";
	APP_video_upload.cookieDomain	= "";
	APP_video_upload.uploadStatus	= -1;
	App_video_upload.haveUploadPresent = 0;//已经上传的视频的百分比
	var bindings = [{
		element: '#uploadOperation',
		event: 'click',
		handler: operation
	}];
	
  function init() {
	  Utils.bindEvents(bindings);
	  APP_video_upload.userId = $$('#clientId').val();
	  APP_video_upload.cookiestr= $$('#cookiestr').val();
	  APP_video_upload.cookieDomain= $$('#cookieDomain').val();
		
	  getUploadStatus();
	  /*
    var circle = new ProgressBar.Circle('#percentContainer', {
      color: '#FFFFFF',
      fill: '#5C98EF',
      strokeWidth: 2,
      trailColor: '#D2DEF0',
      trailWidth: 2,
      duration: 1200,
      text: {
        value: '0'
      },
      step: function(state, bar) {
        bar.setText((bar.value() * 100).toFixed(0));
      }
    });

    // circle.animate(1, View.fail);
    circle.animate(1, View.success);
    */
  }

  function getUploadStatus(){
		if (browser.versions.ios) {	//iphone
      	window.location.href = "objc://getUploadStatus/?pushUploadStutus?"+APP_video_upload.userId;
	    } else {
	        jtoJHandle.getUploadStatus("pushUploadStutus", APP_video_upload.userId);
	    }
	}
	
	function getUploadStatusCallBack(status, total,present) {
		var rate = Math.round(present * 100.0 / total);
		
		APP_video_upload.uploadStatus = status;
		App_video_upload.haveUploadPresent = rate;
		// 0：初始状态，或上传中断（上传尝试固定次数后）  1：正在上传
		//2：上传成功，已合并成功  3：合并失败
      //4：视频文件不存在	
		switch(status){
		case 0:
			$$('#loadContainer').hide();
			$$('.retry-part').show();
//			$$('#uploadStatusIcon').clas
			$$('.center-text').html("网络不给力 上传失败了");
			$$('#uploadOperation').text("重新上传");
			
//			reuploadVideo();
//			getUploadStatus();
			break;
		case 1:
			$$('#loadContainer').show();
			$$('.retry-part').hide();
			$$('.center-text').html("视频正在奋力上传中<br>" + rate + "%");
			
//			var rate = (present * 1.0) / total;
//			var rate2 = rate.ToFixed(2); 
//			var persent =rate2.Slice(2,4)+"%"; 
//			$$('.center-text').html("视频正在奋力上传中 " + persent);
			
//			$$('#uploadOperation').text("重新上传");
			break;
		case 2:
			$$('.retry-part').hide();
			$$('.center-text').html("上传成功");
			CRHloadPage(APP_video_upload.next);
			break;
		case 3:
			$$('.center-text').html("您的视频验证还未完成，请进行验证");
			$$('.retry-part').show();
			$$('#uploadOperation').text("视频验证");
			break;
		case 4:
			$$('.center-text').html("您的视频验证还未完成，请进行验证");
			$$('.retry-part').show();
			$$('#uploadOperation').text("视频验证");
			break;
			
		}
		
		
//		if(status == 0){	//已经中断
//			
//		}else if(status == 1){		//1：正在上传，显示进度提示
//			
//		}else if(status == 2){		//2：上传成功，已合并成功
//			CRHloadPage(APP_video_upload.next);
//		}
//		else if(status == 1){
//			setTimeout(function(){
//					getUploadStatus();
//			    }, 1000);
//			$$(".content-block-title").html("正在上传，请稍候。。");
//		}
//		else if(status == 3 || status == 4){
//			$$(".content-block-title").html("您还未完成视频验证，请进行验证");
//			$$("#reuploadVideo").text("视频验证");
//		}
	}
	window.getUploadStatusCallBack = getUploadStatusCallBack;
	
	function operation(){
		switch(APP_video_upload.uploadStatus){
		case -1:
			getUploadStatus();
			break;
		case 0:
			reuploadVideo();
//			getUploadStatus();
			break;
		case 1:
			break;
		case 2:
			break;
		case 3:
			CRHloadPage("/video?fnf=nextPass");
			break;
		case 4:
			CRHloadPage("/video?fnf=nextPass");
			break;
			
		}
	}
	
	function reuploadVideo(){
		if (browser.versions.ios) { // iphone
			window.location.href = "objc://retryUploadSVideo/?"+APP_video_upload.userId + "?" +APP_video_upload.cookiestr+ "?" +APP_video_upload.cookieDomain;
		} else {
			//
			window.jtoJHandle.retryUploadSVideo(APP_video_upload.userId, APP_video_upload.cookiestr, APP_video_upload.cookieDomain);
		}
	}
	
  return {
    init: init
  };
});
