define(['views/videoView', 'GS', 'text!popup/iframe.html'], function (View, GS, IFrame) {
    APP_video.next = "/audit";
    APP_video.pre = "/returnCallback.do";
    APP_video.orderPage = "/template-3.0/appoint.html";
    APP_video.photoPage = "/photo";
    APP_video.svfCount=0;//单向视频失败次数
    APP_video.initFlag = false;
    APP_video.empId = "";
    APP_video.userId = "";
    APP_video.orgCode = "";
    APP_video.videoType = "1";
    APP_video.test = 0;//测试次数
    APP_video.needWait = true;
    APP_video.waitPositionInSelfOrg = -1;
    APP_video.anychatUrl = "";
    APP_video.anychatPort = "";
    APP_video.showSvideo = "";
    APP_video.isWorkTime = "";
    APP_video.queueTimes = "";//用户加入视频队列次数
    var bindings = [{
        element: '.video-start-button,#video-online-switch',
        event: 'click',
        handler: function(){addVideoUser(this.id);}
    }, {
        element: '.readyBack',
        event: 'click',
        handler: readyBack
    }, {
        element: '.video-wait-button',
        event: 'click',
        handler: waitVideo
    }, {
        element: '.video-retry-button',
        event: 'click',
        handler: retry
    }, {
        element:'#waitLeft',
        event:'click',
        handler:function(){toVideoMain($$(this));}
    }, {
        element: '.videoSelf,.video-restart-button',
        event: 'click',
        handler: function(){startSVideo("1");}
    }, {
        element: '.video-next-button',
        event: 'click',
        handler: function(){startSVideo("2");}
    }, {
        element: '.video-restart-upload',
        event: 'click',
        handler: uploadSvideo
    },{element:'.call95317',event:'click',handler:function(){GS.quickDial('95317');}}];

    //下部弹出框按钮事件
    var afterBindings = [{
        element: '#video_pop .video-next-button',
        event: 'click',
        handler: videoSuccess
    }, {
        element: '#video_pop .video-retry-button',
        event: 'click',
        handler: videoFail
    }];
    var waitBindings = [{
        element: '.video-wait-button',
        event: 'click',
        handler: waitVideo
    }, {
        element: '.video-success-button',
        event: 'click',
        handler: successTest
    }, {
        element: '.video-fail-button',
        event: 'click',
        handler: failTest
    }];

    var timer;
    
    function init() {
    	stopSVideo();
        APP_video.startVideo = "0";
        APP_video.startVideoNum = 0;
        window.rspWeb = rspWeb_THS;
        window.wkPageClick = wkPage;
        window.parsePicUrl=function(a){_CMN.log("videoController.parsePicUrl["+(a?a.length:0)+"]");};
        window.finishAndroidSVideo=function(a){_CMN.log('[finishAndroidSVideo]不应被调用'+a);};
        setTimeout(function(){
        	initData();
            View.render({bindings: bindings});
            initPage();
            _CMN.log("videoController init finish");
        },500);//ths-ios渲染慢
    }

    function wkPage(json){
        var data = JSON.parse(json);
        if(data.event == "click"){
            wkAppClick("video", data.name);
        }else{
            wkPageView(data.name);
        }
    }
    
    function updateVideoQueueflag() {
        if (browser.versions.ios) {
            CRHClientbBrowser.loadObjURL("objc://updateVideoQueueflag/$?updateVideoQueueCallBack");
        } else {
            if(window.jtoJHandle && window.jtoJHandle.updateVideoQueueflag){
                window.jtoJHandle.updateVideoQueueflag("updateVideoQueueCallBack");
            }
        }
    }

    /**
     * 退到手机后台 or 开始单向视频
     */
    function updateVideoQueueCallBack() {
    	console.log("updateVideoQueueCallBack"+Array.prototype.slice.call(arguments));
    	quitVideo();
    	setTimeout(function(){View.backLastStableP();},500);
    }
    window.updateVideoQueueCallBack = updateVideoQueueCallBack;

    function readyBack(){
        request_waitStat = 0;
        khApp.showIndicator();
        CRHloadPage(APP_video.pre);
    }
    
    APP_video.inSvideo = "0";
    var _t1 = 0;//启动单向视频的时间
    /**启动单向视频t 1:正常单向视频;2：直接录制视频*/
    function startSVideo(t){
    	try {
    		quitVideo({"succ":function(){
            	if(!inSVideo()){
            		APP_video.inSvideo='1';
            		var f = startFaceSVideo(t);
            		if(f){
            			_t1=new Date().getTime();
            			setTimeout(function(){View.showReady();},500);
            		}else{stopSVideo();}
            	}else{
            		var t2 = new Date().getTime()-_t1;
            		if(t2>750){//启动单向视频后超过750ms可重新启动
            			stopSVideo();
            			startSVideo(t);
            			_CMN.log("startSVideo reStart;t="+t2+";bv.ios="+browser.versions.ios);
            		}else{_CMN.log("startSVideo err;t="+t2+";bv.ios="+browser.versions.ios);}                		
            	}
            },"fail":function(){stopSVideo();khApp.alert(MESSAGE_TIMEOUT);}});
    	} catch(err) {stopSVideo();}
    }
    /**停止单向视频*/
    function stopSVideo(){
    	APP_video.inSvideo='0';
    }
    /**正在单向视频*/
    function inSVideo(){
    	return APP_video.inSvideo=='1';
    }
    /**无人脸识别的单向视频*/
    function startNoFaceSvideo() {
        CRHloadPage("/goHeadPhoto.do");
    }
    /**有人脸识别的单向视频opentype 1:正常单向视频;2：直接录制视频*/
    function startFaceSVideo(opentype) {
    	var flag = false;
    	try{
	        wkAppClick("video", "自助录制视频");
	        if(!_CMN.isTHS()){
		        var json = {};
		        json.idCardUrl = APP_video.idCardUrl; // 身份证地址
		        json.uploadVideoUrl = APP_video.videoUploadUrl; // 视频上传地址；
		        json.ipAddress =  APP_video.faceVerifyServer; // 人脸识别服务
		        json.cookieDomain = APP_video.cookieDomain;
		        json.thresholdValue = APP_video.threshold; // 人脸识别分值
		        json.authCodeString = APP_video.authCodeString;// 授权吗
		        json.appid = APP_video.appid; // 授权信息
		        json.appSecret = APP_video.appSecret; // 授权码
		
		        json.livessNumber = $$("#livessNumber").val(); // 活体检测个数
		        json.videoMsg = "本人"+APP_video.userName+"自愿在财富证券开户"; // 话术
		        json.userName = APP_video.userName; // 用户姓名
		        json.mPicType = ""; // 暂时无用
		        json.recordtime = $$("#recordtime").val(); // 录制时间
		        json.policeVerifyUrl = ""; // 公安认证地址
		        json.imageBase = $$("#imageBase").val();
		        json.cookiestr = APP_video.cookiestr;
		        json.liveCallback = "liveCallback"; // 活体检测保存结果回调
		        json.businessFlag = "1";//1:开户
		        // 该版本以后才有视频重传功能， 并启用h5段的页面
		        if (appParams.retryUploadSVideo && appParams.retryUploadSVideo >= "20180630") {
		        	_CMN.log("传入参数retryUploadSVideo为"+appParams.retryUploadSVideo+",将启用H5检测结果页面和视频重传功能！");
		        	json.svideoCallBackStatus = "svideoCallBackStatus"; //单向视频结果回调
		        	json.openType = opentype;
		        }
	            if (browser.versions.ios) {
	            	CRHClientbBrowser.loadObjURL("objc://startSVideoVerify/$?" + JSON.stringify(json)+"$?"+APP_video.cookiestr);
	            } else {
	            	json.imageBase = "6A_IN_SERVER";
	                window.jtoJHandle.startSVideoVerify(JSON.stringify(json));
	            }
	            flag = true;
	        }else{
	        	if(opentype=='2'){
	        		flag = oneWayVideo_THS();
	        	}else{
	        		flag = uploadPic_THS("3","takePhoto");
	        	}
	        }
    	}catch(e){
    		_CMN.log("startFaceSVideo error:" + (e.stack||e.message||''));
    		_CMN.log("startFaceSVideo error:[befromFlag="+(befromFlag||'')+"][ua="+(navigator.userAgent||'')+"][app="+(navigator.appVersion||'')+"]");
    	}
    	return flag;
    }
    /**同花顺拍照*/
	function uploadPic_THS(imgType,action){
		var f = false;
		try{
			var json = {
				"action":action,
				"reqId":new Date().getTime(),
				"userId":appParams.userId,
				"param":{
					"imgType":imgType,
					"needLocalOcr":"0"
				}
			};
	        window.thskaihu.reqApp(JSON.stringify(json));
	        _CMN.log("videoController.uploadPic_THS action=["+action+"] imgType=["+imgType+"]");
	        f = true;
		}catch(e){_CMN.log("videoController.uploadPic_THS error["+(e.stack||e.message||'')+"]");}
		return f;
	}
	function setTip(f,info){
		if(f){
			khApp.showIndicator();
		}else{
			khApp.hideIndicator();
		}
	}
	/**同花顺拍照结果做人脸比对*/
	function faceCompareFor_THS(img,succ){
		setTip(true,"正在做人脸识别");
		$$.ajax({
			url: "/compareImageAndUpload.do?rnd=" + new Date().getTime(),
            method: "POST",
            data: {
            	img80: img
            },
            success: function(d){
            	var f = false;
            	try{
            		var data = JSON.parse(d);
        			if (data.result == "0"&&data.score>=APP_video.threshold) {
        				f = succ();
        			}
            	}catch(e){_CMN.isCfWarn(d);_CMN.log("videoController.faceCompareFor_THS error["+(e.stack||e.message||'')+"]");}
            	setTip(false);
            	if(!f){
    				svideoCallBackStatus('{"errorNo":3}');
    			}
    		},
            error:function(){setTip(false);svideoCallBackStatus('{"errorNo":3}');},
            timeout:function(){setTip(false);svideoCallBackStatus('{"errorNo":2}');}
		});
	}
	/**同花顺视频录制*/
	function oneWayVideo_THS(){
		var f = false;
		try{
			var json = {
				"action":"videoRecord",
				"reqId":new Date().getTime(),
				"userId":appParams.userId,
				"param":{
					"recordContent":APP_video.userName+'，您好：请您确定是否本人自愿来财富证券开户，根据系统提示信息回答"是"或"否"',
					"recordType":"2",//1:文案类型;2:语音类型
					"mediaUrl":APP_video.mediaUrlOnVideoRecordForTHS,
					"expectAnswer":"是",
					"iMatchRate":"0",
					"gMatchRate":"0"
				}
			};
	        window.thskaihu.reqApp(JSON.stringify(json));
	        _CMN.log("videoController.oneWayVideo_THS");
	        f = true;
		}catch(e){_CMN.log("videoController.oneWayVideo_THS error["+(e.stack||e.message||'')+"]");}
		return f;
	}
	/**同花顺视频上传*/
	function uploadVideoFor_THS(video){
		if(video){
			APP_video.videoBase64 = video;
		}else{
			video = APP_video.videoBase64||'';
		}
		if(video){
			setTip(true,"正在上传视频");
			$$.ajax({
				url: "/uploadVideoBASE64.do?rnd=" + new Date().getTime(),
	            method: "POST",
	            data: {video : video},
	            success: function(d){
	            	setTip(false);
	    			var data = JSON.parse(d);
	    			if (data.errorNo == "0") {
	    				svideoCallBackStatus('{"errorNo":0}');
	    			}else{
	    				svideoCallBackStatus('{"errorNo":4,"errorInfo":"inSuccess"}');
	    			}
	    		},
	            error:function(){setTip(false);svideoCallBackStatus('{"errorNo":4,"errorInfo":"inError"}');},
	            timeout:function(){setTip(false);svideoCallBackStatus('{"errorNo":4,"errorInfo":"inTimeout"}');}
			});
		}else{
			svideoCallBackStatus('{"errorNo":4,"errorInfo":"noVideo"}');
		}
	}
	//活体检测保存结果回调
    function liveCallback(json) {
        var data = JSON.parse(json);
        $$.ajax({
            url: "/livingBodyDetect.do?rnd=" + new Date().getTime(),
            method: "POST",
            data: {
                error_no : data.error_no,
                error_info: data.error_info
            },
            error:function(){khApp.alert(MESSAGE_TIMEOUT);_CMN.log('livingBodyDetect err');},
            timeout:function(){khApp.alert(MESSAGE_TIMEOUT);_CMN.log('livingBodyDetect err');}
        });
    }
    //单向视频回调
    function svideoCallBackStatus(json) {
    	try{
	    	_CMN.log("videoController.svideoCallBackStatus 单项视频结束["+json+"]");
	    	stopSVideo();
	    	var data = JSON.parse(json);
	    	var errorNo = data.errorNo;
	    	if (errorNo == "0") {
	    		CRHloadPage(APP_video.next);
	    	} else {
	    		View.showVideoResult(APP_video.showSvideo,errorNo);
	    		// 单双向视频默认单向视频 失败一定次数后 展示双向入口
	    		if (APP_video.showSvideo == "4"){
	    			// read X时间内失败的次数+本次是否达到Y次 by redis  (后台检查) 并 write 总失败次数 to redis
	    			checkSvideoFaildTimes($$("#clientId").val(),function(f){
	    				if (f) {
	        		      	$$(".video-btn-bot").show();
	        			} else {
	        				$$(".video-btn-bot").hide();
	        			}
	    			});
	    		}
	    	}
    	}catch(e){_CMN.log("videoController.svideoCallBackStatus error["+(e.stack||e.message||'')+"]");}
    }
    /**支持在离线情况下记录单向视频失败次数*/
    function checkSvideoFaildTimes_OffLine(func){
    	APP_video.svfCount +=1;
    	func(APP_video.svfCount>=(APP_video.svfLimit||3));
    }
    function checkSvideoFaildTimes(userId,func){
    	var f = false;
    	if(!userId){checkSvideoFaildTimes_OffLine(func);_CMN.log("videoController:[#clientId 404]");return;}
    	$$.ajax({
    		method: "POST",
    		data: {"user_id":userId},
    		url: "/checkSvideoFaildTimes.do?rnd=" + new Date().getTime(),
    		success: function(d){
    			var data = JSON.parse(d);
    			if (data.error_no == "0") {
    				if (data.checkedResult == "1") {
    					f = true;
    				}
    				APP_video.svfCount=data.total||APP_video.svfCount;
    				APP_video.svfLimit=data.limit||3;
    				func(f);
    			}else{
    				checkSvideoFaildTimes_OffLine(func);
    			}
    		},
    		error:function(){checkSvideoFaildTimes_OffLine(func);},
    	    timeout:function(){checkSvideoFaildTimes_OffLine(func);}
    	});
    }
    //令客户端上传单向视频
    function uploadSvideo(){
    	try{
    		if(!_CMN.isTHS()){
	    		if (browser.versions.ios) {
	            	CRHClientbBrowser.loadObjURL("objc://retryUploadSVideo");
	            }else{
	                window.jtoJHandle.retryUploadSVideo("1");//"1":仅提供给客户端标识,值随便传
	            }
    		}else{
    			uploadVideoFor_THS();
    		}
    	}catch(e){_CMN.log("retryUploadSVideo error["+(e.stack||e.message||'')+"]");}
    }
    //android视频录制完成回调
    function finishSVideo(errorNo,errorInfo,videoFilePath, imageBase64){
    	try{
	    	_CMN.log("videoController.finishSVideo：errorNo["+errorNo+"];errorInfo["+errorInfo+"];videoFilePath["+videoFilePath+"]");
	    	stopSVideo();
	        if(errorNo==0){
	        	CRHloadPage(APP_video.next);
	        }else{
	            khApp.alert("视频上传不成功："+errorInfo);
	        }
    	}catch(e){_CMN.log("videoController.finishSVideo error["+(e.stack||e.message||'')+"]");}
    }
    //IOS 视频录制完成回调
    function finishIOSSVideo(json){
    	try{
	    	_CMN.log("videoController.finishIOSSVideo:json["+json+"]");
	    	stopSVideo();
	        var obj = JSON.parse(json);
	        if(obj.errorNo==0){
	        	CRHloadPage(APP_video.next);
	        }else{
	            khApp.alert("视频上传不成功："+obj.errorInfo);
	        }
    	}catch(e){_CMN.log("videoController.finishIOSSVideo error["+(e.stack||e.message||'')+"]");}
    }
    /**
     * 等待时返回视频首页
     * 等待时返回视频失败页面
     */
    function toVideoMain($$dom) {
    	quitVideo();
        if(!_CMN.isTHS()){
            stopVideoTimer();
        }
        var arg;
        if($$dom){
    		var lastStableP = $$dom.data('lastStableP')||'1';
    		if(lastStableP.substring(0, 1)=='2'){
    			arg = lastStableP.split('-');
    			$$dom.data('lastStableP','1');
    		}
    	}
        if(arg&&arg.length==3){
        	View.showVideoResult(arg[1],arg[2]);
        }else{
        	View.showReady();
        }
    }

    //继续等待
    function waitVideo() {
        View.toggleDialog('hide');
        addVideoUser();
    }

    //初始化信息
    function initData() {

        //关闭页面时，退出排队
        khApp.onPageBeforeRemove('video', function (page) {
            console.log('About page initialized');
            clearTimeout(timer);
            quitVideo();//退出队列
        });

        window.finishSVideo = finishSVideo;
        window.finishIOSSVideo = finishIOSSVideo;
        window.liveCallback = liveCallback;
        window.svideoCallBackStatus = svideoCallBackStatus;
        APP_video.initFlag = true;
        APP_video.userId = $$("#clientId").val();//用户ID
        APP_video.orgCode = $$("#branchNo").val();//营业部号
        APP_video.videoUserId = $$("#userId").val();
        APP_video.userName = $$("#userName").val();
        APP_video.videoServer = $$("#videoServer").val();
        APP_video.videoPort = $$("#videoPort").val() - 0;//转int
        APP_video.cookieDomain = $$("#cookieDomain").val();
        APP_video.cookiestr = $$("#cookiestr").val();
        APP_video.videoUploadUrl = $$("#videoUploadUrl").val();
        APP_video.picUploadUrl = $$("#picUploadUrl").val();
        APP_video.idCardUrl = $$("#idCardUrl").val();
        APP_video.faceVerifyServer = $$("#faceVerifyServer").val();
        APP_video.authUrl = $$("#authUrl").val();
        APP_video.threshold = $$("#threshold").val() - 0;
        APP_video.showSvideo = $$("#showSvideo").val();
        APP_video.isWorkTime = $$("#isWorkTime").val();
        APP_video.authCodeString = $$("#authCodeString").val();
        APP_video.appid = $$("#appid").val();
        APP_video.appSecret = $$("#appSecret").val();
        APP_video.queuePeopleNum = $$("#queuePeopleNum").val();
        APP_video.queueWaitTime = $$("#queueWaitTime").val();
        APP_video.peopleWaitNumLimit = $$("#peopleWaitNumLimit").val();
        APP_video.peopleWaitTimeLimit = $$("#peopleWaitTimeLimit").val();
        APP_video.videoQueueTimesLimit = $$("#videoQueueTimesLimit").val();
        APP_video.waitNumLimit = $$("#videoStartNum").val();
        APP_video.videoLimitTime = $$("#videoLimitTime").val();
        APP_video.mediaUrlOnVideoRecordForTHS = $$("#mediaUrlOnVideoRecordForTHS").val();
        var device = Framework7.prototype.device;
        if (!_CMN.isTHS() && device.ios && (device.osVersion.indexOf("13")==0)) {
        	var iosAppid = $$("#ios13Appid").val();
        	if (iosAppid && iosAppid.indexOf(appParams.appId) != -1 && APP_video.showSvideo != "2") {
        		APP_video.showSvideo = "2";
        		_CMN.log("ios13系统的用户已强制转行成 仅双向视频");
        	}
        }
    }
    
    //初始化页面展示
    function initPage() {
    	if (APP_video.showSvideo == "1" || APP_video.showSvideo == "4") { //单向
    		$$("#video-top-online").hide();
    		$$("#video-title-online").hide();
    		$$("#video-block-online").hide();
    		$$("#video-top-offline").show();
    		$$("#video-title-offline").show();
    		$$("#video-block-offline").show();
    	} else { //双向
    		$$("#video-top-offline").hide();
    		$$("#video-title-offline").hide();
    		$$("#video-block-offline").hide();
    		$$("#video-top-online").show();
    		$$("#video-title-online").show();
    		$$("#video-block-online").show();
    	}
    	$$(".video-top-wrap").show();
    	$$(".hint-block").show();
    }

    function preparePositionReset(elem1,elem2){
        var marginTop = $$('#videoWait').outerHeight() - $$(elem1).offset().top -
            $$(elem1).outerHeight() - $$(elem2).outerHeight();
        console.log($$('#videoWait').outerHeight() , $$('.content-block-waiting').offset().top ,$$('.content-block-waiting').outerHeight() , $$('.ad-content-block').outerHeight()) ;

        if(marginTop > 35){
            $$(elem2).css({position: 'absolute',bottom: '0'});
        }else{

            $$(elem2).css({'margin-top':'35px',position:'static'});
        }

    }

    function swiperInit(data){
        var str = "";
        var arr= data.imageMap;
        var lbtimes = "";
        for(var i =0;i<arr.length;i++){
            str += "<div class='swiper-slide'>"+
                "<a class='external' href='#'>"+
                "<img class='ad-img' data-image_url='"+arr[i].image_url+"' src='data:image/.jpg;base64,"+arr[i].image_data+"' >"+
                "</a>"+
                "</div>";
            lbtimes = arr[i].times || 5000;
        };
        $$(".swiper-wrapper").html("");
        $$('.swiper-wrapper').append(str);

        var mySwiperSlow = khApp.swiper('.swiper-container', {
            pagination:'.swiper-container .swiper-pagination',
            autoplay:lbtimes,
            speed: 600,
            loop: true,
            autoplayDisableOnInteraction : false
        });
        $$(".ad-img").on("touchstart", function () {
            console.info($$(this).data("image_url"));
            var image_url = $$(this).data("image_url");
            if(image_url && image_url != " "){
                if( APP_video.openWebView != "1"){
                    openIFrame($$(this).data("image_url"));
                }else{
                    openWebView($$(this).data("image_url"));
                }
            }
        });
    }

    //添加视频队列
    function addVideoUser(domId) {
        APP_video.queueFlag = "0";
        APP_video.test = 0;
        stopSVideo();
        if(APP_video.startVideo == "0"){
            APP_video.startVideoTime = new Date();
        }
        APP_video.startVideoNum++;
        View.showWait(null,domId=='video-online-switch');
        $$('.ad-content-block').css({position: 'absolute',bottom: '0'});
        stepSync("reqVideo");
        var queueTimesLimitobj = getVideoQueueTimesLimit();
        var days = queueTimesLimitobj.days;
        $$.ajax({
            method: "POST",
            data: {userId: APP_video.userId, orgCode: APP_video.orgCode, type: APP_video.videoType, days: days},
            url: "/videoQueueUp.do?rnd=" + new Date().getTime(),
            success: function (d) {
                var data = JSON.parse(d);
                if (data.errorNo == 0) {
                    APP_video.needWait = true;
                    APP_video.queueFlag = "1";
                    APP_video.startVideo = "1";
                    APP_video.openWebView = data.openWebView;
                    APP_video.queueTimes = parseInt(data.queueTimes);
                    swiperInit(data);
                    wkPageView("双向等待");
                    queryUserWaitInfo();
                }
                else if (data.errorNo == 3) {//视频已经通过
                    CRHloadPage(APP_video.next);
                } else {
                    khApp.alert(data.errorInfo,
                        function () {
                            toVideoMain();
                        });
                }
            },
            error: function () {
                khApp.alert(MESSAGE_TIMEOUT,
                    function () {
                        toVideoMain();
                    });
            },
            timeout: function () {
                khApp.alert(MESSAGE_TIMEOUT,
                    function () {
                        toVideoMain();
                    });
            }
        });
    }

    //查询用户信息
    var netTest = 0;

    function queryUserWaitInfo() {
        if (!APP_video.initFlag) {
            khApp.alert(MESSAGE_INITUN);
            return;
        }
        if (!APP_video.needWait) {
            return;
        }
        //测试10次后显示 预约
        if (APP_video.test >= 100000) {
            View.toggleDialog('show');
            clearTimeout(timer);
            quitVideo();//退出队列
            return;
        }

        var queryFlag = 1;//第一次queryFlag=0,第一次请求实时返回
        if (APP_video.test == 0) {
            queryFlag = 0;
        }
        $$.ajax({
            method: "POST",
            data: {
                userId: APP_video.userId,
                orgCode: APP_video.orgCode,
                queryFlag: queryFlag,
                waitPositionInSelfOrg: APP_video.waitPositionInSelfOrg
            },
            url: "/videoQueryQueue.do?rnd=" + new Date().getTime(),
            success: function (d) {
            	try{
	                if(inSVideo()){return;}
	                request_waitStat = 0;
	                netTest = 0;
	                var data = JSON.parse(d);
	                if(!APP_video.needWait){return;}
	
	                if (data.errorNo == 0) {
	                    var waitN = 0;
	                    if (APP_video.isSelfOrg == 1) {//1为是按照营业部排队数
	                        waitN = data.waitPositionInSelfOrg;
	                    } else {
	                        waitN = data.waitPosition;
	                    }
	                    if (waitN < 1) {
	                        waitN = 1;
	                    }
	                    if(APP_video.queueFlag == "1"){
	                        APP_video.start_date = new Date();
	                    }
	                    var date = getSecond(APP_video.start_date);
	                    APP_video.waitPositionInSelfOrg = data.waitPositionInSelfOrg;
	                    var videoStatus = data.status;
	                    
	                        var svideoFlag=false;
	                        // 单双向视频默认双向视频 判断是否需要单向入口
	                        if (APP_video.showSvideo == "3") {
	                        	// 获取入口1配置-时间段内的排队人数上限
	                            var peoplelimit = getPeopleWaitNumLimit();
	                            // 获取入口2配置-时间段内的等待时间上限
	                            var waitlimit = getPeopleWaitTimeLimit();
	                            // 获取入口3配置-X时间第Y次加入视频队列
	                            var queueTimesLimitobj = getVideoQueueTimesLimit();
	                            var queueTimesLimit = queueTimesLimitobj.queueTimesLimit;
	                        	// 单向视频入口1.进入队列时排队人数≥X人
	                            if (waitN >= peoplelimit){
	                            	svideoFlag=true;
	                            } 
	                            // 单向视频入口2.进入队列时排队人数＜X人，但等待时间≥N分钟
	                            else if (waitN < peoplelimit && date >= waitlimit) {
	                            	svideoFlag=true;
	                            }
	                            // 单向视频入口3.X时间内第Y次发起双向视频
	                            else if(APP_video.queueTimes >= queueTimesLimit){
	                            	svideoFlag=true;
	                            }
	                        }
	                        View.showSVideoDoor(svideoFlag);
	                        if(svideoFlag){
	                            setTimeout(function(){
	                            	if(APP_video.showSvideo =="2" || APP_video.showSvideo =="3")
	                                preparePositionReset('.content-block-waiting','.ad-content-block');
	                            },100);
	                        }else{
	                        	$$('.ad-content-block').css({position: 'absolute',bottom: '0'});
	                        }
	                    
	                    //1;被应答  2;//建立视频 3;//视频结束 4;//排队超时 5;//坐席预抢答
	                    if (videoStatus == 1 || videoStatus == 2) {			//0:进入排队;1:可以连接视频
	                        APP_video.needWait = false;
	                        View.showWait(waitN);
	                        APP_video.empId = data.empId;
	                        APP_video.anychatUrl = data.anyChatStreamIpOut;//地址
	                        APP_video.anychatPort = data.anyChatStreamPort;//port
	                        startVideo();			//开始视频
	                    } else if (videoStatus == 0 || videoStatus == 5) {
	                        if(appParams.clientTip != '1'){
	                            updateVideoQueueflag();
	                        }
	                        APP_video.queueFlag = "0";
	                        APP_video.needWait = true;
	                        APP_video.test++;
	                        $$(".wait-num").html(waitN);
	                        var min = waitN*3;
	                        $$(".wait-time").html(min+"min");
	                        request_waitStat = 1;//当前为排队状态，发起下次请求
	                        curTime_waitStat = 0;//已等待时间清零
	                        countDown(setTime_waitStat);//每次请求都重新计时
	                        timer = setTimeout(function () {
	                            queryUserWaitInfo();
	                        },2000);
	                    } else {
	                        $$(".wait-num").html('...');
	                        $$(".wait-time").html('...');
	                        APP_video.needWait = true;
	                        APP_video.test++;
	                        khApp.alert('由于应用长时间处于后台或其他原因，您已经退出视频队列，请您重新排队！',
	                            function () {
	                                addVideoUser();
	                            });
	                    }
	                } else {
	                    $$(".wait-num").html('...');
	                    $$(".wait-time").html('...');
	                    APP_video.needWait = false;
	                    APP_video.test++;
	                    khApp.alert('由于应用长时间处于后台或其他原因，您已经退出视频队列，请您重新排队！',
	                        function () {
	                            addVideoUser();
	                        });
	                }
            	}catch(e){_CMN.log("videoController.queryUserWaitInfo error["+(e.stack||e.message||'')+"]");}
            },
            error: function () {
                request_waitStat = 0;
                netTest++;
                if (netTest >= 5) {
                    APP_video.needWait = false;
                    khApp.alert(MESSAGE_TIMEOUT,
                        function () {
                            toVideoMain();
                        });
                } else {
                    timer = setTimeout(queryUserWaitInfo, 5000);
                }
            },
            timeout: function () {
                request_waitStat = 0;
                netTest++;
                if (netTest >= 5) {
                    APP_video.needWait = false;
                    khApp.alert(MESSAGE_TIMEOUT,
                        function () {
                            toVideoMain();
                        });
                } else {
                    timer = setTimeout(queryUserWaitInfo, 5000);
                }
            }
        });
    }
    // 解析切换单向条件1
    function getPeopleWaitNumLimit() {
    	var result=APP_video.peopleWaitNumLimit.split(";");
    	var currTime = APP_video.start_date.getHours()*100 + APP_video.start_date.getMinutes();
    	for(var i=0;i<result.length;i++){
    		var singleResult=result[i].split(",");
    		var timeStrs = singleResult[0].split("-");
    		var beginTime = timeStrs[0].replace(":","");
    		var endTime = timeStrs[1].replace(":","");
    		if (parseInt(endTime) < parseInt(beginTime)) {
    			endTime = endTime + 2400;
    		}
    		if (parseInt(currTime) >= parseInt(beginTime) && parseInt(currTime) < parseInt(endTime)) {
    			var people = parseInt(singleResult[1].replace(/X=/g,""));
    			return people;
    		}
    	}
    	// 返回默认配置
    	return APP_video.queuePeopleNum;
    }
    // 解析切换单向条件2
    function getPeopleWaitTimeLimit() {
    	var result=APP_video.peopleWaitTimeLimit.split(";");
    	var currTime = APP_video.start_date.getHours()*100 + APP_video.start_date.getMinutes();
    	for(var i=0;i<result.length;i++){
    		var singleResult=result[i].split(",");
    		var timeStrs = singleResult[0].split("-");
    		var beginTime = timeStrs[0].replace(":","");
    		var endTime = timeStrs[1].replace(":","");
    		if (parseInt(endTime) < parseInt(beginTime)) {
    			endTime = endTime + 2400;
    		}
    		if (parseInt(currTime) >= parseInt(beginTime) && parseInt(currTime) < parseInt(endTime)) {
    			var wait = parseInt(singleResult[1].replace(/N=/g,"")*60);
    			return wait;
    		}
    	}
    	return APP_video.queueWaitTime;
    }
    // 解析切换单向条件3
    function getVideoQueueTimesLimit() {
    	var result = APP_video.videoQueueTimesLimit.split(",");
    	var days = parseInt(result[0].replace(/X=/g,""));
    	var queueTimesLimit = parseInt(result[1].replace(/Y=/g,""));
    	return {"days":days, "queueTimesLimit":queueTimesLimit};
    }
    
    
    //计算相差秒数
    function getSecond(date1) {
        var date2 = new Date();
        var date3=date2.getTime()-date1.getTime();  //时间差的毫秒数
        // 计算出相差天数
        var days=Math.floor(date3/(24*3600*1000));

        //计算出小时数
        var leave1=date3%(24*3600*1000);    //计算天数后剩余的毫秒数
        var hours=Math.floor(leave1/(3600*1000));
        //计算相差分钟数
        var leave2=leave1%(3600*1000);        //计算小时数后剩余的毫秒数
        var minutes=Math.floor(leave2/(60*1000));
        //计算相差秒数
        var leave3=leave2%(60*1000);     //计算分钟数后剩余的毫秒数
        var seconds=days*24*3600* + hours*24*3600 +minutes*60 + Math.round(leave3/1000);
        return seconds;
    }
    //开始双向视频
    function startVideo() {
        var userId = 10000000 + APP_video.userId * 1 + "";
        var empId = 20000000 + APP_video.empId * 1 + "";
        if(appParams.clientTip == "1"){
            startVideoOfClient(userId,empId);
        }else{
	        if (browser.versions.ios) {
	            CRHClientbBrowser.loadObjURL("objc://startVideo/?" + userId + "?" + empId + "?" + APP_video.anychatUrl + "?" + APP_video.anychatPort + "?" + userId);
	        } else {
	            jtoJHandle.callFunctionWithP(3, userId, empId, APP_video.anychatUrl, APP_video.anychatPort, userId);
	        }
        }
    }
    /**
     * 开始双向视频(同花顺)
     * @param userId
     * @param empId
     */
    function startVideoOfClient(userId,empId){
        var json = {};
        var dataJson = {};
        dataJson.loginName = "user"+userId;  //用户名
        dataJson.loginPwd = "123456";
        dataJson.roomId = userId;
        dataJson.roomPwd = "";
        dataJson.anychatIp = APP_video.anychatUrl;
        dataJson.anychatPort = APP_video.anychatPort;

        json.action = "videoWitness";
        json.reqId = new Date().getTime();
        json.param = dataJson;
        window.thskaihu.reqApp(JSON.stringify(json));

    }

    function stopVideoTimer() {
        try{
            if(browser.versions.ios){
                CRHClientbBrowser.loadObjURL("objc://stopVideoTimer/?");
            }
        }catch (e){

        }
    }
    //退出队列
    function quitVideo(c) {
        request_waitStat = 0;
        APP_video.test = 0;
        APP_video.needWait = false;	//不再查询
        $$.ajax({
            method: "POST",
            url: "/videoQuitQueue.do?rnd=" + new Date().getTime(),
            success:function(d){if(c&&c.succ){c.succ.call();}},
            error:function(){_CMN.log("quitVideo err");if(c&&c.fail){c.fail.call();}},
            timeout:function(){_CMN.log("quitVideo timeout");if(c&&c.fail){c.fail.call();}}
        });
    }

    function userSubmitToAudit(){
        $$.ajax({
            method: "POST",
            data: {},
            url: "/userSubmitToAudit.do?rnd=" + new Date().getTime(),
            success:function(d){_CMN.log("videoController.userSubmitToAudit d["+d+"]");},
            error:function(){_CMN.log("videoController.userSubmitToAudit err");},
            timeout:function(){_CMN.log("videoController.userSubmitToAudit timeout");}
        });
    }
    //双向视频完成(flag=1:成功,2:异常,3:不通过,4:link failed;5:?)
    APP_video.finishVideo=function(flag){
    	try{
    		_CMN.log("videoController.finishVideo flag["+flag+"]");
	        if(flag==1){
	            videoSuccess();
	        }else if(flag==2||flag==4){
	            View.showReVideo();
	        }else if(flag==3){
	            View.renderPopup({
	                model: {"fail": true, "failText": "视频验证不通过，请重新验证身份证"},
	                bindings:afterBindings
	            });
	            khApp.popup('.popup');
	        }else if(flag==5){
	            addVideoUser();
	        }
    	}catch(e){_CMN.log("videoController.finishVideo error["+(e.stack||e.message||'')+"]");}
    };

	//双向视频完成-ths
    function rspWeb_THS(json){
    	try{
    		_CMN.log("videoController.rspWeb_THS json=["+(function(j){var a=JSON.parse(j);if(a.param&&a.param.imgData){a.param.imgData='...';}if(a.param&&a.param.videoData){a.param.videoData='...';}return JSON.stringify(a);})(json)+"]");
    		var obj = JSON.parse(json);
    		if(obj.action == "takePhoto"){
    			faceCompareFor_THS(encodeURI(obj.param.imgData).replace(/\+/g,'%2B'),oneWayVideo_THS);
    			return;
    		}else if(obj.action == "videoRecord"){
    			uploadVideoFor_THS(encodeURI(obj.param.videoData).replace(/\+/g,'%2B'));
    			return;
    		}
            var obj_data = obj.param;
            var flag = obj_data.anychatRsp;
            if(flag == "SYS:10000"){
                videoSuccess();
                stepSync("videoResult");
            }else if(flag == "ths:10001" || flag == "ths:10002" || flag == "ths:10003"){ //视频意外中断请重新开始
                View.showReVideo();
            }else if(flag == "SYS:10001"){	//视频不通过
                View.renderPopup({
                    model:{"fail": true, "failText": "视频验证不通过，请重新验证身份证"},
                    bindings: afterBindings
                });
                setTimeout(function(){
                    khApp.popup('.popup');
                },500);
            }
    	}catch(e){_CMN.log("videoController.rspWeb_THS error["+(e.stack||e.message||'')+"]");}
    }
    //通过后下一步
    function videoSuccess(){
    	userSubmitToAudit();
        khApp.closeModal();
        khApp.showIndicator();
        CRHloadPage(APP_video.next);
    }

    window.videoSuccess=videoSuccess;
    //视频不通过将回到拍照页面
    function videoFail() {
        khApp.closeModal();
        khApp.showIndicator();
        CRHloadPage(APP_video.photoPage);
    }

    function retry() {
        //视频重新发起
        addVideoUser();
    }


    function waitPopupShow() {
        View.renderWaitPopup({
            bindings: waitBindings
        });
    }

    function successTest() {
        clearTimeout(timer);
        khApp.showIndicator();
        $$.ajax({
            url: 'api/video-success.json',
            type: 'GET',
            success: function (data) {
                data = JSON.parse(data);
                if (data.errorNo === 0) {
                    renderPopup({
                        model: data.model,
                        bindings: afterBindings
                    });
                    khApp.popup('.popup');
                }
                khApp.hideIndicator();
            }
        });

        mainView.loadPage('agreement.html');
    }

    function failTest() {
        clearTimeout(timer);
        khApp.showIndicator();
        $$.ajax({
            url: 'api/video-fail.json',
            type: 'GET',
            success: function (data) {
                data = JSON.parse(data);
                if (data.errorNo === 1) {
                    renderPopup({
                        model: data.model,
                        bindings: afterBindings
                    });
                    khApp.popup('.popup');
                }
                khApp.hideIndicator();
            }
        });
    }

    //计时器
    var timer_waitStat = null;
    var setTime_waitStat = 30;//超时时间设置为30s
    var curTime_waitStat = 0;//使用时间
    var leftTime_waitStat = 0;//剩余时间
    var request_waitStat = 0;//请求队列状态，为1则是当前请求无响应
    function countDown(setTime_waitStat) {
        if (timer_waitStat) {
            clearTimeout(timer_waitStat);
        }
        curTime_waitStat++;
        leftTime_waitStat = setTime_waitStat - curTime_waitStat;
        if (leftTime_waitStat > 0) {
            if (request_waitStat == 1) {
                timer_waitStat = setTimeout(function () {
                    countDown(setTime_waitStat);
                }, 1000);
            } else {
                //如果不是请求状态则清零
                curTime_waitStat = 0;
            }
        } else {
            //提示用户重新排队
            khApp.modal({
                title: '温馨提示',
                text: "如您长时间停留在该页面，请退出系统重新发起视频或更换网络环境后再发起视频",
                buttons: [{
                    text: '确定',
                    onClick: function () {
                        toVideoMain();
                    }
                }]
            });
        }
    }
    /**打开广告*/
    function openIFrame(src) {
        var iframe = document.createElement('iframe');
        var compiledTemplate = Template7.compile(IFrame);
        var model = {};
        model.webUrl = SERVICE_DOMAIN_URL;
        var renderTemplate = compiledTemplate({model: model});
        $$('.popup').html('').append(renderTemplate);
        $$('.popup #iframe').append(iframe);
        iframe.src = src;
        iframe.width = '100%';
        iframe.height = '100%';
        iframe.id = 'myIframe';
        khApp.popup('.popup');
        $$("#returnVideo").on("click",function(){
            khApp.closeModal();
        });
    }
    return {
        init: init
    };
});