define(['utils'], function (Utils) {
	var viewModelType = '';
	function render(params) {
		var template = $$('#collectTemplate').html();
		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate({model: params.model,SERVICE_DOMAIN_URL:SERVICE_DOMAIN_URL||""});
		$$('#collectContent').html(renderTemplate);
		showPhotoFront(params.frontUrl);
		showPhotoBack(params.backUrl);
		Utils.bindEvents(params.bindings);
	}
	function showPhotoFront(url) {
		if(url){
			$$('#showFront').attr("src", url);
			appParams.frontUrl = url;
			$$(".parea-2 .button.uploadFront").addClass("active").html("重新上传");
		}else{
			$$('#showFront').attr("src", SERVICE_DOMAIN_URL+'/template-3.0/img/cardfront.png');
			appParams.frontUrl = '';
			$$(".parea-2 .button.uploadFront").removeClass("active").html("上传身份证正面");
		}
	}
	function showPhotoBack(url) {
		if(url){
			$$('#showBack').attr("src", url);
			appParams.backtUrl = url;
			$$(".button.uploadBack").addClass("active").html("重新上传");
		}else{
			$$('#showBack').attr("src", SERVICE_DOMAIN_URL+'/template-3.0/img/cardback.png');
			appParams.backtUrl = '';
			$$(".button.uploadBack").removeClass("active").html("上传身份证反面");
		}
	}
	function showFullInfo(flag){
		var This = $$(".collect-sh");
		if(flag!==true&&flag!==false){
			flag = !This.hasClass("active");
		}
		if(flag){
			This.addClass("active");
			$$(".li-hide").show();
			viewModelType = 22;
		}else{
			This.removeClass("active");
			$$(".li-hide").hide();
			viewModelType = 21;
		}
		var src = flag?"arrowss_a.png":"arrowss.png";
    	This.find(".collect-o-h").attr("src",(SERVICE_DOMAIN_URL||"")+"/template-3.0/img/"+src);
	}
	/**type in(11:连拍页,12:非联拍页;21:详情页部分显示;22:详情页全显)*/
	function showModel(type){
		viewModelType = type;
		if(viewModelType==11||viewModelType==12){
			$$(".parea-3").show();
			$$(".parea-4").show();
			$$(".parea-5").show();
			$$(".parea-6").hide();
			if(viewModelType==11){
				$$(".parea-1").show();
				$$(".parea-2").hide();
			}else{
				$$(".parea-1").hide();
				$$(".parea-2").show();
			}
		}else if(viewModelType==21||viewModelType==22){
			$$(".parea-1").hide();
			$$(".parea-2").show();
			$$(".parea-3").hide();
			$$(".parea-4").hide();
			$$(".parea-5").hide();
			$$(".parea-6").show();
			if(viewModelType==21||viewModelType==22){
				showFullInfo(viewModelType==22);
			}
			var $dom = $$("textarea[name=address]");
			$dom.trigger('change');
            if(browser.versions.android){
            	if($dom[0].rows>1&&$dom[0].offsetHeight<42&&$dom[0].scrollHeight<42){
    				setTimeout(function(){
    					$dom.trigger('change');
    					_CMN.log("textarea高度二次调整ua:["+navigator.userAgent+"]");
    				},1200);
    			}
            }
		}
		return true;
	}
	function getViewModelType(){
		return viewModelType;
	}
	return {
		render: render,
		showPhotoFront: showPhotoFront,
		showPhotoBack: showPhotoBack,
		showModel: showModel,
		showFullInfo:showFullInfo,
		getViewModelType:getViewModelType
	};
});