define(['utils'], function (Utils) {

	function init(params) {
		Utils.bindEvents(params.bindings);
	}

	function render(params) {
		var template = $$('#collectTemplate').html();
		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate({model: params.model});

		$$('#collectContent').html(renderTemplate);
		Utils.bindEvents(params.bindings);
		
		if(appParams.frontUrl != ""){
			showPhotoFront(appParams.frontUrl);
		}
		if(appParams.backUrl != ""){
			showPhotoBack(appParams.backUrl);
		}
		if(appParams.faceUrl != ""){
			showPhotoFace(appParams.faceUrl);
		}
		
	}

    function showPhotoFront(url) {
        $$('#showFront').attr("src", url);
        $$(".cardFrontTitle").html("点击重新上传身份证正面照片");
    }

    function showPhotoBack(url) {
        $$('#showBack').attr("src", url);
		 $$(".cardBackTitle").html("点击重新上传身份证反面照片");
    }

	function showPhotoFace(url) {
		$$('#face').html('<img src=' + url + ' alt="" height="160">');
	}

	return {
		init: init,
		render: render,
		showPhotoFront: showPhotoFront,
		showPhotoBack: showPhotoBack,
		showPhotoFace: showPhotoFace
	};
});
