define(['utils'], function (Utils) {

	function render(params) {
		Utils.bindEvents(params.bindings);

//		Utils.setButtonPosition('.department-next-button');
	}
	function refereeInfo(params){
		var template = $$('#recTemplate').html();
		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate({model: params.attrs});
		$$('#recMesssages').append(renderTemplate);
	}

	function renderSelect(params) {
		var template = $$('#departmentTemplate').html();
		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate({model: params.model});

		$$('#departmentContent').append(renderTemplate);
		Utils.bindEvents(params.bindings);
		resetSelect();
	}

	function renderName(text) {
		$$('.department-name').find('h2').text(text);
	}

	function renderBadge(str) {
		if(str == 'selected'){
			$$('.department-badge').html('您选择的是');
		}else if(str == 'nearby'){
			$$('.department-badge').html('已为您定位最近营业部');
		}
	}

	function resetSelect() {
		$$('.smart-select select').each(function () {
			this.selectedIndex = -1;
		});
	}

	return {
		render: render,
		renderName: renderName,
		renderBadge: renderBadge,
		renderSelect: renderSelect,
		refereeInfo: refereeInfo
	};
});
