define(['utils'], function (Utils) {

    var template = "";

	function init(params) {
        template = "";
		Utils.bindEvents(params.bindings);
	}

    function render(params) {
    	if($$("#recInfo").length==1){
    		if(!template) {
                template = $$('#recTemplate').html()||template;
    		}
            $$('#recInfo').html(Template7.compile(template)({model: params.model}));
            $$("#recInfo").show();
    	}
    }

    function renderBank(params) {
        var template = $$('#bankListTemplate').html();
        var compiledTemplate = Template7.compile(template);
        var renderTemplate = compiledTemplate({bankPage: params.model});

        $$('.bank-list-picker .picker-modal-inner').html(renderTemplate);

        Utils.bindEvents(params.bindings);
        Utils.bottomFixedAdapt('.next-btn-block','.prepare');
    }


	function resetBtn() {
		$$('.login-getcode').html('重新获取验证码');
		$$('.login-getcode').removeClass('disabled');
	}

	function reRenderBtn(leftTime) {
		$$('.login-getcode').html(leftTime + '秒后重新获取');
	}

	function inputBlur() {
		$$('.mobile').blur();
		$$('.password').blur();
	}
	
	function changeType(title, explain){
		//根据这个参数判断是不是其他APP来源
		if(!befromFlag || befromFlag=="sjkh-hundsun"){
			$$('.sliding').html(title);
		}else{
			$$('.sliding').html(title);
		}
		$$('.desc').html(explain);
	}

	return {
		init: init,
        render: render,
        renderBank: renderBank,
		resetBtn: resetBtn,
		reRenderBtn: reRenderBtn,
		inputBlur: inputBlur,
		changeType: changeType
	};
});