define(['utils'], function (Utils) {

	function init(params) {
		Utils.bindEvents(params.bindings);
	}

	function render(params) {
		var template = $$('#resetChannelTemplate').html();
		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate({model: params.model});

		$$('.current-channel').html(renderTemplate);
		Utils.bindEvents(params.bindings);
	}

	return {
		init: init,
		render: render
	};
});
