define(['utils'], function (Utils) {

	function render(params) {
		var template = $$('#verifyTemplate').html();
		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate({model: params.model});

		$$('#verifyContent').html(renderTemplate);
		Utils.bindEvents(params.bindings);
		Utils.setButtonPosition('.verify-next-button');
	}

	function showMaterial(url) {
		$$('#verifyMaterial').html('<img src=' + url + ' alt="" height="160"><div class="title">点击上传辅助证件照片</div>');
	}

	return {
		render: render,
		showMaterial: showMaterial
	};
});
