define(['utils'], function (Utils) {

  function render(params) {
    var template = $$('#verifyTemplate').html();
    var compiledTemplate = Template7.compile(template);
    var renderTemplate = compiledTemplate(params.model);

    $$('#verifyContent').append(renderTemplate);
    Utils.bindEvents(params.bindings);
  }

  function resetBtn() {
    $$('#getCode').html('重新获取验证码');
    $$('#getCode').removeClass('disabled');
  }

  function reRenderBtn(leftTime) {
    $$('#getCode').html(leftTime + '秒后重新获取');
  }

  function inputBlur() {
    $$('.mobile').blur();
    $$('.code').blur();
  }

  return {
    render: render,
    resetBtn: resetBtn,
    reRenderBtn: reRenderBtn,
    inputBlur: inputBlur
  };
});
