require.config({
  paths: {
    Framework7: 'libs/framework7',
    text: 'libs/text',
    GS: 'services/globalService',
    tpl: '../tpl',
    popup: '../popup'
  },
  shim: {
    Framework7: {
      exports: 'Framework7'
    }
  },
  urlArgs:"rnt=" + jsFileVersion //这个地方为js加载时间戳，目前不要当前时间
});

require(['Framework7', 'router', 'utils'], function (Framework7, Router, Utils) {
  window.$$ = window.Dom7;

  window.isOpenNew;
  var device = Framework7.prototype.device;

  if (device.android) {
    window.khApp = new Framework7({
      animatePages: false,
      swipeout: false,
      sortable: false,
      cache: false,
      pushState: false,
      swipeBackPage: false,
      preloadPreviousPage: false,
      popupCloseByOutside: false,
      animateNavBackIcon: true,
      modalTitle: '开户提示',
      modalButtonOk: '确定',
      modalButtonCancel: '取消',
      smartSelectBackText: '返回',
      smartSelectBackTemplate: '<div class="left sliding"><a href="#" class="back link"><i class="icon iconfont icon-back"></i><span>{{backText}}</span></a></div>'
    });
  } else {
    window.khApp = new Framework7({
      cache: false,
      pushState: false,
      swipeBackPage: false,
      preloadPreviousPage: false,
      popupCloseByOutside: false,
      animateNavBackIcon: true,
      modalTitle: '开户提示',
      modalButtonOk: '确定',
      modalButtonCancel: '取消',
      smartSelectBackText: '返回',
      smartSelectBackTemplate: '<div class="left sliding"><a href="#" class="back link"><i class="icon iconfont icon-back"></i><span>{{backText}}</span></a></div>'
    });
  }

  window.mainView = khApp.addView('#mainView', {
    dynamicNavbar: true
  });

  // Android 下的一些常见 Hack
  if (device.android) {

    // 重设 body 高度，默认的高度为 100%，在 Android 下会有问题
    Utils.resetBodyHeight();

    //// 防止在 Android 下 Smart Select 组件点击穿透
    //$$('body').on('touchend', '.smart-select-page li', function (e) {
    //  e.stopPropagation();
    //});
  }

    $$(document).on('change keydown keypress keyup paste cut', '.resizeable', Utils.resizeTextarea);
  Router.init();
});
