define(['views/appointView', 'GS'], function (View, GS) {

	var bindings = [{
		element: '.appoint-done-button',
		event: 'click',
		handler: appointDone
	},{
		element: '#appoint-faq-to-login',
		event: 'click',
		handler: returnPre
	}];
	
	function returnPre(){
		CRHloadPage(GS.startPage);
	}
	function init() {
		$$("#login_nav_left").hide();
		View.render({
			bindings: bindings
		});
	}

	function appointDone() {
		var formData = khApp.formToJSON('#appointContent');
		var time = formData["appoint-time"];
		if(!time){
			khApp.alert("请选择预约时间");
			return;
		}
		order(time);
	}
	
	//预约
	function order(oderTime){
		$$.ajax({
			url: "/videoOrder.do?rnd=" + new Date().getTime(),
	      	method: "POST",
	      	data: {time:oderTime},
      		success: function(data){
	      		var data = JSON.parse(data);
		        if(!data){
		        	khApp.alert("预约不成功");
		        	return;
		        }
		        if(data["errorNo"]==0){
		        	mainView.loadPage(GS.startPage);
	        	}else{
	        		khApp.alert("预约不成功");
	        	}
	      	},
	      	error: function(){
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		},
	   		timeout: function(){
	   			khApp.alert(MESSAGE_TIMEOUT);
	   		}
		});
	}

	return {
		init: init
	};
});
