define(['views/auditView', 'GS'], function (View, GS) {

	var APP_audit = {};
	APP_audit.title = "";
	APP_audit.content = "";
	APP_audit.tagUrl = "";
	APP_audit.picUrl = "";
	APP_audit.activityDetailsUrl = "";
	
	APP_audit.tg_broker = "";
	APP_audit.tg_phone = "";
	APP_audit.tg_name = "";
	APP_audit.tg_saleNo = "";
	APP_audit.tg_idCard = "";
	APP_audit.tg_riskLevel = "";
	APP_audit.touguUrl = "";
	

	var bindings = [{
		element: '#open_new_account',
		event: 'click',
		handler: function(){
			$$.ajax({
				url: '/openNewAccount.do?rnd=' + new Date().getTime(),
				type: 'POST',
				success: function (data) {
					data = JSON.parse(data);
					if (data.errorNo == 0) {
						mainView.loadPage("/video");
					}else{
						khApp.alert(data.errorInfo);
					}
				}
			});
		}
	},{
		element: '#fresh',
		event: 'click',
		handler: fresh
	},{
		element: '#downloadApp',
		event: 'click',
		handler: downloadApp
	},{
		element: '.button-fill',
		event: 'click',
		handler: share
	},{
		element: '.detail',
		event: 'click',
		handler: detail
	},{
		element: '#goTougu',
		event: 'click',
		handler: goInterest
	}];
	
	function fresh(){
		khApp.showIndicator();
		CRHloadPage('/audit');
	}

	/**
	 * 活动分享
	 * */
	function share(){

		if(browser.versions.ios){
			window.location.href = "objc://clickShare/$?" + APP_audit.title
						+ "$?" + APP_audit.content + "$?" + APP_audit.tagUrl
				+ "$?" + APP_audit.picUrl;
		}else{
			jtoJHandle.share(APP_audit.title,APP_audit.content,APP_audit.tagUrl,APP_audit.picUrl);
		}
	}

	/***
	 *
	 * 活动详情
	 */
	function detail(){
		if (browser.versions.ios) {	//iphone
			window.location.href = "objc://updateApp/$?" + APP_audit.activityDetailsUrl;
		} else {
			jtoJHandle.updateApp('3', APP_audit.activityDetailsUrl);
		}
	}
	var sz_sta = 0;
	var sh_sta = 0;
	
	var zd_sz_sta = 0;
	var zd_sh_sta = 0;
	
	function init() {
		var show_tougu = $$("#show_tougu").val();
		if(show_tougu != 1){
			$$("#goTougu").hide();
		}
		khApp.showIndicator();
		$$.ajax({
			url: '/getAudit.do?rnd=' + new Date().getTime(),
			type: 'POST',
			success: function (data) {
				data = JSON.parse(data);
				if (data.errorNo == 0) {
					if(typeof(appParams)=='object'){ // 成功后清除证件图片缓存
						appParams.frontUrl="";
						appParams.backUrl="";
					}
					var models={};
					var model = [];
					APP_audit.title = data.title;
					APP_audit.content = data.content;
					APP_audit.tagUrl = data.tagUrl;
					APP_audit.picUrl = data.picUrl;
					
					//投顾信息
					APP_audit.tg_broker = data.tg_broker;
					APP_audit.tg_phone = data.tg_phone;
					APP_audit.tg_name = data.tg_name;
					APP_audit.tg_saleNo = data.tg_saleNo;
					APP_audit.tg_idCard = data.tg_idCard;
					APP_audit.tg_riskLevel = data.tg_riskLevel;
					APP_audit.touguUrl =  data.touguUrl;
						
					APP_audit.activityDetailsUrl = data.activityDetailsUrl;
					
					model.push({key:"客户姓名",val:data.accountInfoMap.userName});
					model.push({key:"资金账户",val:data.accountInfoMap.fund_account_status=="1"&&data.accountInfoMap.fund_account?data.accountInfoMap.fund_account:"受理中"});
					model.push({key:"上海A股",val:data.accountInfoMap.stockAccountSHFlag=="1"&&data.accountInfoMap.stockAccountSH?data.accountInfoMap.stockAccountSH:data.accountInfoMap.stockAccountSH_msg});
					model.push({key:"深圳A股",val:data.accountInfoMap.stockAccountSZFlag=="1"&&data.accountInfoMap.stockAccountSZ?data.accountInfoMap.stockAccountSZ:data.accountInfoMap.stockAccountSZ_msg});
					
					//场内基金
					if(data.accountInfoMap.stock_account){
						for(var i=0;i<data.accountInfoMap.stock_account.length;i++){
							if(data.accountInfoMap.stock_account[i].account_name == "上海场内基金"){
								model.push({key:data.accountInfoMap.stock_account[i].account_name,val:data.accountInfoMap.stock_account[i].open_status=="1"&&data.accountInfoMap.stock_account[i].stock_account?data.accountInfoMap.stock_account[i].stock_account:data.accountInfoMap.stock_account[i].open_result});
								sh_sta = 1;
							}
							if(data.accountInfoMap.stock_account[i].account_name == "深圳场内基金"){
								model.push({key:data.accountInfoMap.stock_account[i].account_name,val:data.accountInfoMap.stock_account[i].open_status=="1"&&data.accountInfoMap.stock_account[i].stock_account?data.accountInfoMap.stock_account[i].stock_account:data.accountInfoMap.stock_account[i].open_result});
								sz_sta = 1;
							}
						}
					}
					
					if(sh_sta == 0){
						model.push({key:"上海场内基金",val:"未申请"});
					}
					if(sz_sta == 0){
						model.push({key:"深圳场内基金",val:"未申请"});
					}
					
					//中登基金
					if(data.accountInfoMap.ofstock_account){
						for(var i=0;i<data.accountInfoMap.ofstock_account.length;i++){
							if(data.accountInfoMap.ofstock_account[i].fund_company == "中登上海"){
								model.push({key:data.accountInfoMap.ofstock_account[i].fund_company,val:data.accountInfoMap.ofstock_account[i].open_status=="1"&&data.accountInfoMap.ofstock_account[i].stock_account?data.accountInfoMap.ofstock_account[i].stock_account:data.accountInfoMap.ofstock_account[i].open_result});
								zd_sh_sta = 1;
							}
							if(data.accountInfoMap.ofstock_account[i].fund_company == "中登深圳"){
								model.push({key:data.accountInfoMap.ofstock_account[i].fund_company,val:data.accountInfoMap.ofstock_account[i].open_status=="1"&&data.accountInfoMap.ofstock_account[i].stock_account?data.accountInfoMap.ofstock_account[i].stock_account:data.accountInfoMap.ofstock_account[i].open_result});
								zd_sz_sta = 1;
							}
						}
					}
					if(zd_sh_sta == 0){
						model.push({key:"中登上海",val:"未申请"});
					}
					if(zd_sz_sta == 0){
						model.push({key:"中登深圳",val:"未申请"});
					}
					
					
					model.push({key:"三方存管",val:data.accountInfoMap.bank_name});
					if(data.open_new_account==1){
						model.push({key:"三方存管",val:data.accountInfoMap.bank_name});
					}
					models.accountInfo=model;
					if(data.open_new_account==1){
						models.showNewAccount=true;
					}
					//判断是否开户成功
					if(data.accountInfoMap.fund_account_status=="1"&&data.accountInfoMap.fund_account){
						models.openAccountSuccess=true;
					}
					if(data.channelself == 1){
						models.channelself=true;
					}else{
						models.channelself=false;
					}
					View.render({
						bindings: bindings,
						model: models
					});
					if(data.activity == "0"){
						$$(".event").hide();
					}
					var show_tougu = $$("#show_tougu").val();
					if(show_tougu != 1){
						$$("#goTougu").hide();
					}
					khApp.hideIndicator();
				}else{
					khApp.hideIndicator();
					khApp.alert(data.errorInfo);
				}
			}
		});
	}

	function downloadApp(){
		var url = $$("#idAppUrl").val();
		if (browser.versions.ios) {	//iphone
	        window.location.href = "objc://updateApp/$?" + url;
	    } else {
	        jtoJHandle.updateApp('3', url);
	    }
	}
	
	function goInterest(){
		var url = APP_audit.touguUrl + '?phone=' + encodeURIComponent( APP_audit.tg_phone)
											+'&name=' + encodeURIComponent(APP_audit.tg_name)
											+'&idCard=' + encodeURIComponent(APP_audit.tg_idCard)
											+'&saleNo=' + encodeURIComponent(APP_audit.tg_saleNo)
											+'&broker=' + encodeURIComponent(APP_audit.tg_broker)
											+'&riskLevel=' + encodeURIComponent(APP_audit.tg_riskLevel);
//		window.location.href = url;
		window.open(url);
//		if (browser.versions.ios) {	//iphone
//	        window.location.href = "objc://updateApp/$?" + url;
//	    } else {
//	        jtoJHandle.updateApp('3', url);
//	    }
	}
	return {
		init: init
	};
});
