define(['utils'], function (Utils) {

    var APP_audit = {};
    APP_audit.title = "";
    APP_audit.content = "";
    APP_audit.tagUrl = "";
    APP_audit.picUrl = "";
    APP_audit.activityDetailsUrl = "";

    APP_audit.tg_broker = "";
    APP_audit.tg_phone = "";
    APP_audit.tg_name = "";
    APP_audit.tg_saleNo = "";
    APP_audit.tg_idCard = "";
    APP_audit.tg_riskLevel = "";
    APP_audit.touguUrl = "";
    var sz_sta = 0;
    var sh_sta = 0;

    var zd_sz_sta = 0;
    var zd_sh_sta = 0;

  var bindings = [{
      element: '#openResultContent .button-fill',
      event: 'click',
      handler: function(){
          mainView.loadPage(this.attributes.tourl.value);
      }
  }];


  function init() {
    khApp.showIndicator();
      $$.ajax({
          url: '/getAudit.do?rnd=' + new Date().getTime(),
          type: 'POST',
          success: function (data) {
              data = JSON.parse(data);
              if (data.errorNo == 0) {

                  var models={};
                  var model = [];
                  APP_audit.title = data.title;
                  APP_audit.content = data.content;
                  APP_audit.tagUrl = data.tagUrl;
                  APP_audit.picUrl = data.picUrl;

                  //投顾信息
                  APP_audit.tg_broker = data.tg_broker;
                  APP_audit.tg_phone = data.tg_phone;
                  APP_audit.tg_name = data.tg_name;
                  APP_audit.tg_saleNo = data.tg_saleNo;
                  APP_audit.tg_idCard = data.tg_idCard;
                  APP_audit.tg_riskLevel = data.tg_riskLevel;
                  APP_audit.touguUrl =  data.touguUrl;

                  APP_audit.activityDetailsUrl = data.activityDetailsUrl;

                  model.push({key:"客户姓名",val:data.accountInfoMap.userName});
                  model.push({key:"资金账户",val:data.accountInfoMap.fund_account_status=="1"&&data.accountInfoMap.fund_account?data.accountInfoMap.fund_account:"受理中"});
                  if(appParams.open_type != 5){
                      model.push({key:"上海A股",val:data.accountInfoMap.stockAccountSHFlag=="1"&&data.accountInfoMap.stockAccountSH?data.accountInfoMap.stockAccountSH:data.accountInfoMap.stockAccountSH_msg});
                      model.push({key:"深圳A股",val:data.accountInfoMap.stockAccountSZFlag=="1"&&data.accountInfoMap.stockAccountSZ?data.accountInfoMap.stockAccountSZ:data.accountInfoMap.stockAccountSZ_msg});
                  }

                  //场内基金
                  if(data.accountInfoMap.stock_account){
                      for(var i=0;i<data.accountInfoMap.stock_account.length;i++){
                          if(data.accountInfoMap.stock_account[i].account_name == "上海场内基金" && appParams.open_type != 5){
                              model.push({key:data.accountInfoMap.stock_account[i].account_name,val:data.accountInfoMap.stock_account[i].open_status=="1"&&data.accountInfoMap.stock_account[i].stock_account?data.accountInfoMap.stock_account[i].stock_account:data.accountInfoMap.stock_account[i].open_result});
                          }
                          if(data.accountInfoMap.stock_account[i].account_name == "深圳场内基金" && appParams.open_type != 5){
                              model.push({key:data.accountInfoMap.stock_account[i].account_name,val:data.accountInfoMap.stock_account[i].open_status=="1"&&data.accountInfoMap.stock_account[i].stock_account?data.accountInfoMap.stock_account[i].stock_account:data.accountInfoMap.stock_account[i].open_result});
                          }
                      }
                  }
                  //中登基金
                  if(data.accountInfoMap.ofstock_account){
                      for(var i=0;i<data.accountInfoMap.ofstock_account.length;i++){
                          if(data.accountInfoMap.ofstock_account[i].fund_company == "中登上海"){
                              model.push({key:data.accountInfoMap.ofstock_account[i].fund_company,val:data.accountInfoMap.ofstock_account[i].open_status=="1"&&data.accountInfoMap.ofstock_account[i].stock_account?data.accountInfoMap.ofstock_account[i].stock_account:data.accountInfoMap.ofstock_account[i].open_result});
                              zd_sh_sta = 1;
                          }else if(data.accountInfoMap.ofstock_account[i].fund_company == "中登深圳"){
                              model.push({key:data.accountInfoMap.ofstock_account[i].fund_company,val:data.accountInfoMap.ofstock_account[i].open_status=="1"&&data.accountInfoMap.ofstock_account[i].stock_account?data.accountInfoMap.ofstock_account[i].stock_account:data.accountInfoMap.ofstock_account[i].open_result});
                              zd_sz_sta = 1;
                          }else if(data.accountInfoMap.ofstock_account[i].fund_company == "南方基金"){
                              model.push({key:"财富宝",val:data.accountInfoMap.ofstock_account[i].open_status=="1"&&data.accountInfoMap.ofstock_account[i].stock_account?data.accountInfoMap.ofstock_account[i].stock_account:data.accountInfoMap.ofstock_account[i].open_result});
                          }else{
                              model.push({key:data.accountInfoMap.ofstock_account[i].fund_company,val:data.accountInfoMap.ofstock_account[i].open_status=="1"&&data.accountInfoMap.ofstock_account[i].stock_account?data.accountInfoMap.ofstock_account[i].stock_account:data.accountInfoMap.ofstock_account[i].open_result});
                          }
                      }
                  }

                  model.push({key:"三方存管",val:data.accountInfoMap.bank_name});
                  if(data.open_new_account==1){
                      model.push({key:"三方存管",val:data.accountInfoMap.bank_name});
                  }
                  if(appParams.open_type == 5){
                	  model.push({key:"开户营业部",val:data.branchName});
                  }
                  models.accountInfo=model;
                  models.protocals = data.signList;
                  render({
                      bindings: bindings,
                      model: models
                  });

                  khApp.hideIndicator();
              }else{
                  khApp.hideIndicator();
                  khApp.alert(data.errorInfo);
              }
          }
      });
  }
    function render(params) {
        var template = $$('#auditInfoTemplate').html();
        var compiledTemplate = Template7.compile(template);
        var renderTemplate = compiledTemplate({model: params.model});

        $$('#auditInfoContent').html(renderTemplate);
    }

  return {
    init: init
  };
});
