define(['utils'], function (Utils) {

    var APP_badRecordList = {};
    APP_badRecordList.closeCallback=null;

    var bindings = [{
        element: '#leftback',
        event: 'click',
        handler: getValue
    },{
        element: '#badRecordContent input',
        event: 'change',
        handler: inputChange
    }];


    function inputChange() {
        if(!$$(this)[0].checked){
            $$(this).parent().find('.item-inner').css('background-image','');
        }
    }

    function init(query) {
        APP_badRecordList.closeCallback=query.closeCallback;
        if(query.showCallback){
            var data=window[query.showCallback]();
            if(data.badrecordData){
                render({
                    model: data,
                    bindings: bindings
                });
            }
        }
    }

    function getValue() {
        //alert(111);
        var str = "";
        var badValue = "";
        var that = $$('#badRecordContent .list-block li');

        for (var i = 0; i < $$(that).length; i++) {
            if ($$(that).eq(i).find('input').is(':checked')) {
                badValue += ($$(that).eq(i).find('input').val() + ",");
                str += ($$(that).eq(i).find('.item-title').html() + ',');
            }
        }
        console.log(badValue);
        var badRecord = str.substr(0, str.length - 1);
        sessionStorage.clear('badRecord');
        sessionStorage.clear('badValue');
        window.sessionStorage.setItem("badRecord",badRecord);
        window.sessionStorage.setItem("badValue",badValue);

        mainView.back();
        if(APP_badRecordList.closeCallback!=null){
            window[APP_badRecordList.closeCallback]();
        }

    }

    function defultChecked() {
        var value = window.sessionStorage.getItem("records");
        var that = $$('#badRecordContent .list-block li');
        //alert(value);
        if (value == null || value == 'undefined') {
            return
        } else {
            for( var i =0 ; i<that.length;i++){
                if(value.indexOf(that.eq(i).find('.item-title').html() ) != -1){
                    // $$('.list-block li').eq(i).find('input').prop('checked',true);
                    that.eq(i).find('input')[0].checked = true;
                    that.eq(i).find('.item-inner').css({
                        'background-image':'url(https://sjkh.cfzq.com/template-3.0/img/icon-checked.png)',
                        'background-repeat': 'no-repeat',
                        'background-position': '95% center',
                        'background-size': 'auto 13px'
                    });
                }
            }
        }
    }

    function render(params) {
        var template = $$('#badRecordTemplate').html();
        var compiledTemplate = Template7.compile(template);
        var renderTemplate = compiledTemplate({model: params.model});
        $$('#badRecordContent').html(renderTemplate);
        defultChecked();
        Utils.bindEvents(params.bindings);

    }

    return {
        init: init
    };
});