define(['views/collectIdcardView', 'utils','libs/LCalendar/LCalendar'], function (View, Utils,LCalendar) {
	var APP_collect = {};
	APP_collect.pre = "";
	APP_collect.next = "/userprofile";
	APP_collect.cookie = "";
	
	APP_collect.frontPicUploaded = "0";
	APP_collect.backPicUploaded = "0";
    APP_collect.imageBaseFront = "";
    APP_collect.imageBaseBack = "";
    APP_collect.name = "";
    APP_collect.ceraddr = "";
    APP_collect.code = "";
    APP_collect.issued_depart = "";
    APP_collect.id_begindate = "";
    APP_collect.id_enddate = "";
    APP_collect.cidLongTerm = "";
    APP_collect.minzu_code = "";
    APP_collect.needLocalOcr = "1";/**是否需要本地ocr（默认需要，若不需要本地ocr，走服务端，同花顺会返回0）**/
    APP_collect.signValue = "";
    APP_collect.canLianPai = true;
    APP_collect.canClientOCR = true;
    APP_collect.business_flag = "ocr_IdCardInfo";
	var bindings = [{
        element: '#choosemale',
        event: 'click',
        handler: chooseMale
    },{
		element: '.collect-next-button',
		event: 'click',
		handler: nextSubmit
	},{
		element: '.alertUploadMenu',
		event: 'touchstart',
		handler: function(e){
			alertUploadMenu(this,e);
		}
	},{
        element: '.collect-sh',
        event: 'click',
        handler: function(){
        	View.showFullInfo();
        }
    },{
        element: 'input[name=revenue]',
        event: 'change',
        handler: revenueChange
    },{
        element: '#protocalLink',
        event: 'click',
        handler: function() {
            mainView.loadPage('/template-3.0/protocal.html?econtract_id='+$$(this).data("id"));
        }
    },{
    	element: 'input[type="text"],textarea',
    	event: 'change',
        handler: function(){
        	checkInfo('edit',this.id);
        }
    },{
    	element: 'input[type="text"],textarea',
    	event: 'input',
        handler: function(){
        	$(this).trigger("change");
        }
    }];
	function formatDate(date,sp){
		var v = '';
		try{
			if(date){
				var d=new Date(date),m=''+(d.getMonth()+1),day=''+d.getDate(),y=d.getFullYear();
				if (m.length < 2) m = '0' + m;
				if (day.length < 2) day = '0' + day;
				v = [y, m, day].join(sp||'');
			}
		}catch(e){}
		return v;
	}
	function checkIdNo(id){var city={11:"1",12:"1",13:"1",14:"1",15:"1",21:"2",22:"2",23:"2",31:"3",32:"3",33:"3",34:"3",35:"3",36:"3",37:"3",41:"4",42:"4",43:"4",44:"4",45:"4",46:"4",50:"5",51:"5",52:"5",53:"5",54:"5",61:"6",62:"6",63:"6",64:"6",65:"6",71:"7",81:"8",82:"8",91:"9"};var f=true;if(!id||!/^\d{6}(18|19|20|21)\d{2}(0[1-9]|1[012])(0[1-9]|[12]\d|3[01])\d{3}(\d|X)$/i.test(id)){f=false;}else if(!city[id.substr(0,2)]){f=false;}else{var c=id.split('');var factor=[7,9,10,5,8,4,2,1,6,3,7,9,10,5,8,4,2];var parity=[1,0,'X',9,8,7,6,5,4,3,2];var sum=0;for(var i=0;i<17;i++){sum+=id[i]*factor[i];}if(parity[sum%11]!=id[17].toUpperCase()){f=false;}}return f;}
	/**拍照弹框*/
	function alertUploadMenu(target,event){
		_CMN.log("collectIdcardController.alertUploadMenu");
		event.stopPropagation();
        setTimeout(function() {
            if(appParams.clientTip != "1"){
            	if(APP_collect.canClientOCR){
            		openexocr(target);
            	}else{
            		APP_collect.business_flag = "IdCardInfo";
            		takePictures(target);
            	}
            }else{
            	alertUploadMenu_THS(target);
            }
        }, 100);
	}
	/**拍照-服务端*/
	function takePictures(target){
		try{
			var conf = {"uploadPicImg_ALL":"all","uploadPicBtn":"all","uploadPicImg_FRONT":"front","uploadPicImg_BACK":"back"};
			var type = conf[target.id]||"front";/**type in (front,back,face,all)*/
	        if (browser.versions.ios){
	        	CRHClientbBrowser.loadObjURL("objc://takePictures/?"+type+"?"+APP_collect.cookie);
			} else {
				var conf1 = {"front":0,"back":1};
				var picType = conf1[type]||0;
	            window.jtoJHandle.takePictures(picType,APP_collect.cookie,type);
			}
	        _CMN.log("collectIdcardController.takePictures type=["+type+"]");
		}catch(e){_CMN.log("takePictures error["+(e.stack||e.message||'')+"]:target.id=["+target.id+"]browser.versions.ios=["+browser.versions.ios+"]");}
	}
	/**拍照回调-服务端*/
	function takePicturesCallBack(json){
		try{
			_CMN.log("collectIdcardController.takePicturesCallBack json=["+json+"]");
			if(!json){_CMN.log("sdk配置文件中uploadPicUrl可能配置错误;请检查nginx日志;");return;}
			var obj = eval('(' + json + ')');
			if (obj.errorNo === 0) {
				var picType = obj.picType;
				var url = obj.src;
				if(picType=='front'){
					if(url&&url.indexOf("data:image/.jpg;base64,")==0){
						if (browser.versions.ios){
							APP_collect.imageBaseFront = url.substring("data:image/.jpg;base64,".length);
						}else{
							APP_collect.imageBaseFront = encodeURIComponent(url.substring("data:image/.jpg;base64,".length));
						}
						View.showPhotoFront(url);
						APP_collect.frontPicUploaded = "1";
					}
				}else if(picType=='back'){
					if(url&&url.indexOf("data:image/.jpg;base64,")==0){
						if (browser.versions.ios){
							APP_collect.imageBaseBack = url.substring("data:image/.jpg;base64,".length);
						}else{
							APP_collect.imageBaseBack = encodeURIComponent(url.substring("data:image/.jpg;base64,".length));
						}
						View.showPhotoBack(url);
						APP_collect.backPicUploaded = "1";
					}
				}
				if(APP_collect.frontPicUploaded=="1"&&APP_collect.backPicUploaded=="1"){
					khApp.showIndicator();
					$$.ajax({
						url: '/getUserPresenceCF.do?rnd=' + new Date().getTime(),
						type: 'GET',
						timeout: 15000,
						success: function (d1) {
							var d = JSON.parse(d1);
							khApp.hideIndicator();
							if (d.errorNo == "0") {
								var u = d.user;
								var b = (/^\d{17}[\dXx]$/.test(u.identityCode))?u.identityCode.substring(6,14):"";
								var sex = (/^\d{17}[\dXx]$/.test(u.identityCode))?(u.identityCode.substring(16,17)%2==0?"女":"男"):"";
								var v = formatDate(u.deliveryDate)+"-"+(u.foreverFlag!='0'?"长期有效":formatDate(u.dueDate));
								openexocrCallBack({
			                		"type":"front",
			                		"username":u.userName,
			                		"idNumber":u.identityCode,
			                		"address":u.address,
			                		"nation":u.minzu,
			                		"birthday":(/^\d{8}$/.test(b)?(b.substring(0,4)+"-"+b.substring(4,6)+"-"+b.substring(6,8)):""),
			                		"sex":sex,
			                		"imageJsonStr":"",
			                		"isServerOcr":true});
								openexocrCallBack({"type":"back",
			                		"issueAuthority":u.deliveryOrg,
			                		"validity":v,
			                		"imageJsonStr":"",
			                		"isServerOcr":true});
							} else {
								_CMN.log("getUserPresenceCF error["+(d.errorNo||'')+"]");
							}
						},
						error: function(){khApp.hideIndicator();khApp.alert(MESSAGE_TIMEOUT);},
						timeout: function(){khApp.hideIndicator();khApp.alert(MESSAGE_TIMEOUT);}
					});
				}
			} else {
				khApp.alert(obj.errorInfo);
			}
		}catch(e){
			_CMN.log("takePicturesCallBack error["+(e.stack||e.message||'')+"]:json=["+json+"]");
		}
	}
	/**拍照*/
	function openexocr(target){
		try{
			APP_collect.needShowAll = false;
			var conf = {"uploadPicImg_ALL":"all","uploadPicBtn":"all","uploadPicImg_FRONT":"front","uploadPicImg_BACK":"back"};
			var type = conf[target.id]||"front";/**type in (front,back,face,all)*/
	        if (browser.versions.ios){
	        	CRHClientbBrowser.loadObjURL("objc://openexocr/?"+type+"?openexocrCallBack");
			} else {
	            window.jtoJHandle.openexocr(type,"openexocrCallBack");
			}
	        _CMN.log("collectIdcardController.openexocr type=["+type+"]");
		}catch(e){_CMN.log("openexocr error["+(e.stack||e.message||'')+"]:target.id=["+target.id+"]browser.versions.ios=["+browser.versions.ios+"]");}
	}
	/**拍照回调*/
	function openexocrCallBack(d) {
		var data = (typeof(d)=='string')?JSON.parse(d):d;
		_CMN.log("collectIdcardController.openexocrCallBack type=["+data.type+"]");
		if (data.type == "front") {
			APP_collect.name = data.username;
			APP_collect.code = data.idNumber;
			APP_collect.ceraddr = data.address;
			APP_collect.minzu_code = data.nation;
			APP_collect.birthday = data.birthday;
			APP_collect.sex = data.sex;
			if(d.isServerOcr!==true){
				APP_collect.imageBaseFront = data.imageJsonStr;
				if(APP_collect.imageBaseFront){
					APP_collect.frontPicUploaded = "1";
					View.showPhotoFront("data:image/front;base64,"+APP_collect.imageBaseFront);
				}
			}
			var r = writeInfo(0);
			if(r.needShowAll){
	        	APP_collect.needShowAll = true;
	        }
		} else {
			APP_collect.issued_depart = data.issueAuthority;
			var val = (data.validity||'').split("-");
			if(val.length==2){
				if(/\d{8}/.test(val[0])){
					APP_collect.id_begindate = val[0].substring(0,4)+"-"+val[0].substring(4,6)+"-"+val[0].substring(6,8);
				}
				if(/\d{8}/.test(val[1])){
					APP_collect.id_enddate  = val[1].substring(0,4)+"-"+val[1].substring(4,6)+"-"+val[1].substring(6,8);
				}else if(val[1].indexOf("长期")!=-1){
					APP_collect.cidLongTerm = "1";
					APP_collect.id_enddate = "长期有效";
				}
			}
			if(d.isServerOcr!==true){
				APP_collect.imageBaseBack = data.imageJsonStr;
				if(data.imageJsonStr){
			        View.showPhotoBack("data:image/front;base64,"+APP_collect.imageBaseBack);
			        APP_collect.backPicUploaded = "1";
				}
			}
	        var r = writeInfo(1);
	        if(r.needShowAll){
	        	APP_collect.needShowAll = true;
	        }
		}
		if(APP_collect.backPicUploaded=="1"&&APP_collect.frontPicUploaded=="1"){
			View.showModel(APP_collect.needShowAll?22:21);
			setPlaceholder(true);
			if(d.isServerOcr){
				if (data.type!="front"){
					return;
				}
			}
			faceCompare({
				img:APP_collect.imageBaseFront,
				ready:function(){
					khApp.showPreloader('正在验证身份证信息,请稍后...');
				},
				succ:function(){
					khApp.hidePreloader();
					_CMN.log("collectIdcardController.faceCompare succ");
				},
				fail:function(errCode,mess){
					_CMN.log("collectIdcardController.faceCompare fail["+errCode+"]");
					khApp.hidePreloader();
					khApp.modal({
						title: '开户提示',
		                text: '<div class="">'+(mess||'人脸识别失败，请重新上传身份证人像面。')+'</div>',
		                buttons: [{
		                	text:'我知道了',
		                	onClick:function(){
		                		APP_collect.imageBaseFront = '';
		                		APP_collect.frontPicUploaded = '0';
		                		View.showPhotoFront('');
		                		setNextBtn();
		                	}
		                }]
		            });
				}
			});
		}
    }
	/**人脸识别*/
	function faceCompare(c){
		c.ready();
		$$.ajax({
			url: '/compareImgWithDefaultImg.do?rnd=' + new Date().getTime(),
			type: 'POST',
			data: {"image_6A":c.img},
			timeout: 15000,
			success: function (d){
				try{
					var data = JSON.parse(d);
					if (data.errorNo=="0") {
						c.succ();
					} else {
						c.fail('noface');
					}
				}catch(e){
					c.fail('errorData:'+d);
				}
			},
			error:function(){c.fail('error');},
			timeout:function(){c.fail('timeout');}
		});
	}
	function writeInfo(type){
    	if(type == 0){
			$$("input[name=name]").val(APP_collect.name);
			$$("input[name=cid]").val(APP_collect.code);
			try{
				$$("textarea[name=address]").val(APP_collect.ceraddr).trigger('change');
			}catch(e){_CMN.log("collectIdcardController.writeInfo error["+(e.stack||e.message||'')+"]");}
			$$("input[id=choosemale]").val(APP_collect.sex);
			$$("input[id=minzu_code]").val(APP_collect.minzu_code);
			$$("input[id=birthTime]").val(APP_collect.birthday);
    	} else if (type == 1){
    		$$("input[name=issued_depart]").val(APP_collect.issued_depart);
    		$$("input[name=id_begindate]").val(APP_collect.id_begindate);
    		$$("input[name=id_enddate]").val(APP_collect.id_enddate);
    	}
    	return checkInfo(type);
    }
	var CheckMap = {
		"name":{"e":0,"func":function(){
			var v = trim($$("input[name=name]").val()||'');
			if(DataLength(v)>60){
				this.e=2;
			}else if(!v){
				this.e=1;
			}else{
				this.e=0;
			}
			APP_collect.name = v;
			if($$("input[name=name]").val()!=v){
				$$("input[name=name]").val(v);
			}
		}},
		"cid":{"e":0,"link":["cid","choosemale","birthTime"],"func":function(){
			var v = trim($$("input[name=cid]").val()||'');
			if(checkIdNo(v)){
				this.e=0;
			}else if(!v){
				this.e=1;
			}else{
				this.e=3;
			}
			APP_collect.code = v;
			if($$("input[name=cid]").val()!=v){
				$$("input[name=cid]").val(v);
			}
		}},
		"address":{"e":0,"func":function(){
			var v = trim($$("textarea[name=address]").val()||'');
			if(DataLength(v)>80){
				this.e=4;
			}else if(!v){
				this.e=1;
			}else{
				this.e=0;
			}
			APP_collect.ceraddr = v;
			if($$("textarea[name=address]").val()!=v){
				$$("textarea[name=address]").val(v);
			}
		}},
		"choosemale":{"e":0,"func":function(){
			var v = $$("input[id=choosemale]").val();
			this.e = 1;
			if(v){
				var v1 = $$("input[name=cid]").val();
				if(checkIdNo(v1)){
					if(v==(v1.substring(16,17)%2==0?"女":"男")){
						this.e=0;
					}else{
						this.e=7;
					}
				}else{
					this.e = 0;
				}
			}
		}},
		"minzu_code":{"e":0,"func":function(){
			var v = trim($$("input[id=minzu_code]").val()||'');
			if(DataLength(v)>10){
				this.e=8;
			}else if(!v){
				this.e=1;
			}else{
				this.e=0;
			}
			APP_collect.minzu_code = v;
			if($$("input[id=minzu_code]").val()!=v){
				$$("input[id=minzu_code]").val(v);
			}
		}},
		"birthTime":{"e":0,"func":function(){
			var v = $$("input[id=birthTime]").val();
			this.e = 1;
			if(/^\d{4}\-\d{1,2}\-\d{1,2}$/.test(v)){
				var v1 = $$("input[name=cid]").val();
				if(checkIdNo(v1)){
					var arr = v.match(/\d{1,4}/g);
					if((arr[0]+(arr[1].length==1?"0":"")+arr[1]+(arr[2].length==1?"0":"")+arr[2])==v1.substring(6,14)){
						this.e = 0;
					}else{
						this.e = 7;
					}
				}else{
					this.e = 0;
				}
			}else{
				$$("input[id=birthTime]").val('');
			}
		}},
		"issued_depart":{"e":0,"func":function(){
			var v = trim($$("input[name=issued_depart]").val()||'');
			if(DataLength(v)>30){
				this.e=5;
			}else if(!v){
				this.e=1;
			}else{
				this.e=0;
			}
			APP_collect.issued_depart = v;
			if($$("input[name=issued_depart]").val()!=v){
				$$("input[name=issued_depart]").val(v);
			}
		}},
		"id_begindate":{"e":0,"link":["id_enddate"],"func":function(){}},
		"id_enddate":{"e":0,"func":function(){
			var v1 = $$("input[name=id_begindate]").val();
			var v2 = $$("input[name=id_enddate]").val();
			var v3 = "";
			this.e = (!v1||!v2)?1:0;
			if(this.e==0){
				if(/^\d{4}\-\d{1,2}\-\d{1,2}$/.test(v2)){
					if(v2<formatDate(new Date(),'-')){
						this.e=9;
					}else if(v2<=v1){
						this.e=6;
					}
				}else{
					v3="1";
				}
			}
			APP_collect.id_begindate = v1;
			APP_collect.id_enddate = v2;
			APP_collect.cidLongTerm= v3;
		}}
	};
	function checkInfo(type,oneDOM){
		var toCN = {"name":"姓名","cid":"身份证号码","address":"身份证住址","choosemale":"性别","minzu_code":"民族","birthTime":"出生日期","issued_depart":"签发机关","id_begindate":"有效期限","id_enddate":"有效期限"};
		var eList = ["[]不能为空","[]不能超过30个汉字","[]不符合要求，请重新填写","[]不能超过40个汉字","[]不能超过15个汉字","[]起始日期应早于截止日期","[]与身份证号码不符","[]不能超过5个汉字","您的身份证已经过期"];
		var err_no =0;
		var err_info = [];
		var needShowAll = false;
		var l = null;
		if(type == 0){
			l = ['name','cid','address','choosemale','minzu_code','birthTime'];
    	} else if (type == 1){
    		l = ['issued_depart','id_begindate','id_enddate'];
    	} else if (type == 'edit'){
    		var c = CheckMap[oneDOM];
    		if(c){
    			l = c.link||[oneDOM];
    		}
    	} else if(type == 'submit'){
    		l = ['name','cid','address','issued_depart','id_begindate','id_enddate','choosemale','minzu_code','birthTime'];
    	}
		if(!l){return;}
		for(var i=0;i<l.length;i++){
			var c = CheckMap[l[i]];
			c.func.call(c);
			if(c.e!=0){
				err_no += c.e;
				var einfo = eList[c.e-1].replace('[]',toCN[l[i]]);
				err_info.push(einfo);
				$$("."+l[i]+"_label").addClass("warnings");
				if(!needShowAll&&'choosemale,minzu_code,birthTime'.indexOf(l[i])!=-1){
					needShowAll = true;
				}
			}else{
				$$("."+l[i]+"_label").removeClass("warnings");
			}
		}
		if(needShowAll){
			View.showFullInfo(true);
		}
		if(type != 'submit'){
			setNextBtn();
		}
		return {
			err_no:err_no,
			err_info:err_info,
			needShowAll:needShowAll
		};
	}
	function setPlaceholder(f){
		var c = [{"id":"name","n":"姓名","t":1},{"id":"cid","n":"身份证号码","t":1},{"id":"address","n":"身份证住址","t":1},{"id":"issued_depart","n":"签发机关","t":1},{"id":"choosemale","n":"性别","t":2},{"id":"minzu_code","n":"民族","t":1}];
		for(var i=0;i<c.length;i++){
			var v = f?((c[i].t=="1"?"请填写":"请选择")+c[i].n):"";
			$$("#"+c[i].id).attr("placeholder",v);
		}
	}
	/**同花顺拍照弹框*/
	function alertUploadMenu_THS(target){
		khApp.actions([
           [{
               text: '拍照(推荐使用)',
               color: 'black',
               onClick: function () {
            	   uploadPic_THS(target,"takePhoto");
               }
           },{
               text: '从相册选取',
               color: 'black',
               onClick: function () {
            	   uploadPic_THS(target,"pickAlbum");
               }
           }],
           [{
                   text: '取消',
                   color: 'black'
           }]
       ]);
	}
	/**同花顺拍照*/
	function uploadPic_THS(target,action){
		try{
			_CMN.log("collectIdcardController.uploadPic_THS action=["+action+"] target.id=["+target.id+"]");
			var json = {
				"action":action,
				"reqId":new Date().getTime(),
				"userId":appParams.userId,
				"param":{
					"imgType":(target.id==="uploadPicImg_BACK")?"2":"1",
					"needLocalOcr":"1"
				}
			};
	        window.thskaihu.reqApp(JSON.stringify(json));
		}catch(e){_CMN.log("collectIdcardController.uploadPic_THS error["+(e.stack||e.message||'')+"]");}
	}
	/**同花顺回调*/
	function rspWeb_THS(json){
		try{
			_CMN.log("collectIdcardController.rspWeb_THS json=["+(function(j){var a=JSON.parse(j);if(a.param){a.param.imgData='...';}return JSON.stringify(a);})(json)+"]");
	        var o = JSON.parse(json);
	        var act = o.action;
	        if(act == "takePhoto" || act == "pickAlbum"){
	        	var d = o.param;
	        	APP_collect.needLocalOcr = d.needLocalOcr;
	        	var url = encodeURI(d.imgData).replace(/\+/g,'%2B');
	        	if(d.imgType==1){
	        		var b = d.birthday;
	        		var i=d.idNo;
                	openexocrCallBack({
                		"type":"front",
                		"username":d.name,
                		"idNumber":i,
                		"address":d.address,
                		"nation":d.nation,
                		"birthday":(/^\d{8}$/.test(b)?(b.substring(0,4)+"-"+b.substring(4,6)+"-"+b.substring(6,8)):""),
                		"sex":(/^\d{17}[\dXx]$/.test(i)?(i.substring(16,17)%2==0?"女":"男"):""),
                		"imageJsonStr":url});
	        	}else if(d.imgType==2){
	        		openexocrCallBack({"type":"back",
                		"issueAuthority":d.idIssued,
                		"validity":(d.startDate||'')+"-"+(d.endDate||''),
                		"imageJsonStr":url});
	        	}
	        }else if(act == "jumpApp"){
	            alert("jumpApp");
	        }
		}catch(e){_CMN.log("collectIdcardController.rspWeb_THS error["+(e.stack||e.message||'')+"]");}
    }
	function revenueChange() {
        setTimeout(function(){
        	var flag = $$("input[name=revenue]")[0].checked;
        	setNextBtn();
            if(!flag){
                khApp.modal({
                    title:  '开户提示',
                    text: '<div style="text-align:left;color:#4d4d4d">非中国税收居民无法进行网上开户，请您前往就近营业部开户</div>',
                    buttons: [{
                        text: '我知道了',
                        onClick: function () {
                            khApp.closeModal();
                        }
                    }]
                });
            }
        }, 500);
    }
	function setNextBtn() {
		var err_no = 1;
		var err_info = "";
		var a = APP_collect.backPicUploaded=="1"&&APP_collect.frontPicUploaded=="1";
		if(!a){
			err_info = "请上传身份证照片";
		}
		var b = true;
		for(var name in CheckMap){
			if(CheckMap[name]["e"]==1){
				b = false;
				break;
			}
		}
		if(!b){
			err_info = "请确定您的身份证信息";
		}
		var c = $$("input[name=revenue]")[0].checked;
		if(!c){
			err_info = "非中国税收居民无法进行网上开户，请您前往就近营业部开户";
		}
		if(a&b&c){
			err_no = 0;
			$$('.collect-next-button').removeClass('disabled');
		}else{
			$$('.collect-next-button').addClass('disabled');
		}
		return {
			err_no:err_no,
			err_info:err_info
		};
    }
	function calendarInit(){
		var d = new Date();
		var year = d.getFullYear();
		var month = d.getMonth() + 1;
		var date = d.getDate();
		var conf =[{'trigger':'#id_begindate','type': 'date','minDate':'1900-01-01','maxDate':year+"-"+month+"-"+date},
		           {'trigger':'#id_enddate','type': 'date','minDate':year+"-"+month+"-"+date,'maxDate':(year+30)+"-"+month+"-"+date,'hasUnlimitedDate':true},
		           {'trigger':'#birthTime','type': 'date','minDate':'1900-01-01','maxDate':year+"-"+month+"-"+date}];
		for(var i=0;i<conf.length;i++){
			var l = new LCalendar();
			l.init(conf[i]);
		}
    }
	function chooseMale() {
        khApp.actions([
            [{
                text: '<span class="male-span">请选择您的性别</span>',
                color: 'black',
                onClick: function () {
                    return;
                }
            },
            {
                text: '女',
                color: 'black',
                onClick: function () {
                    $$("#choosemale").val("女");
                    checkInfo('edit','choosemale');
                }
            },
            {
                text: '男',
                color: 'black',
                onClick: function () {
                    $$("#choosemale").val("男");
                    checkInfo('edit','choosemale');
                }
            }],
            [
                {
                    text: '取消',
                    color: 'black'
                }
            ]
        ]);
        $$(".male-span").parent().addClass("male-btn");
    }
	function reqProtocalId(func) {
		$$.ajax({
			url: '/reqProtocalId.do?rnd=' + new Date().getTime(),
			type: 'GET',
			timeout: 15000,
			success: function (d) {
				var data = JSON.parse(d);
				if (data.errorNo === 0) {
					func(data);
				} else {
					khApp.alert(data.errorInfo);
				}
			},
			error: function(){
				khApp.alert(MESSAGE_TIMEOUT);
			},
			timeout: function(){
				khApp.alert(MESSAGE_TIMEOUT);
			}
		});
	}
	/**埋点*/
	function wkPage(json){
		var data = JSON.parse(json);
		if(data.event == "click"){
			wkAppClick("collectIdcard", data.name);
		}else{
			wkPageView("collectIdcard");
		}
	}
	
	function init() {
		APP_collect.canLianPai = true;/**支持连拍*/
		APP_collect.canClientOCR = true;/**本地OCR*/
		APP_collect.frontPicUploaded = "0";
		APP_collect.backPicUploaded = "0";
		window.parsePicUrl = takePicturesCallBack;
		window.openexocrCallBack = openexocrCallBack;
        window.rspWeb = rspWeb_THS;
        window.wkPageClick = wkPage;
        window.updateVideoQueueCallBack=function(){};
		reqProtocalId(function(data){
			var model = data.model;
			APP_collect.cookie = model.cookiestr;
			APP_collect.canLianPai = model.canLianPai=="1";
			APP_collect.canClientOCR = model.canClientOCR=="1";
			View.render({
				model: model,
				bindings: bindings
			});
			if(model.rectification ==="1"){
				if(model.frontSrc){
					View.showPhotoFront(model.frontSrc);
					APP_collect.frontPicUploaded = "1";
				}
				if(model.backSrc){
					View.showPhotoBack(model.backSrc);
					APP_collect.backPicUploaded = "1";
				}
			}
			APP_collect.name = model.name;
			APP_collect.code = model.code;
			APP_collect.ceraddr = model.ceraddr;
			APP_collect.minzu_code = model.minzu_code;
			var v = model.code;
			APP_collect.birthday = /^\d{17}[\dXx]$/.test(v)?(v.substring(6,10)+"-"+v.substring(10,12)+"-"+v.substring(12,14)):"";
			APP_collect.sex = /^\d{17}[\dXx]$/.test(v)?(v.substring(16,17)%2==0?"女":"男"):"";
			APP_collect.issued_depart = model.issued_depart;
			APP_collect.cidLongTerm = model.cidLongTerm;
			APP_collect.id_begindate = model.id_begindate;
			if(model.id_begindate){
				APP_collect.id_enddate = (model.cidLongTerm=='1')?"长期有效":model.id_enddate;
			}else{
				APP_collect.id_enddate = "";
			}
			calendarInit();
			setPlaceholder(true);
			if(APP_collect.backPicUploaded=="1"&&APP_collect.frontPicUploaded=="1"){
				var r1 = writeInfo(0);
				var r2 = writeInfo(1);
				View.showModel((r1.needShowAll||r2.needShowAll)?22:21);
			}else{
				View.showModel(APP_collect.canLianPai?11:12);
			}
			_CMN.log("collectIdcardController init finish");
		});
	}
    var Monitor = {
		status:0,/**0:未监控;1:监控中*/
		actList:[],
		addAct:function(action){
			this.actList.push(action);
			action.setMonitor(this);
		},
		runAct:function(conf){
			this.conf = conf;
			for(var i=0;i<this.actList.length;i++){
				this.actList[i].status=0;
				var checkFunc = this.actList[i].check;
				if(typeof(checkFunc)=='function'){
					var errorInfo = checkFunc();
					if(errorInfo){
						this.conf.failCheck(errorInfo);
						return;
					}
				}
			}
			if(this.conf.finishCheck()){
				this.run();
			}
		},
		run:function(){
			if(this.status!=1){
				for(var i=0;i<this.actList.length;i++){
					if(!this.actList[i].preAct){
						this.actList[i].run();
					}
				}
				this.status=1;
			}else{
				console.log("resubmit");
			}
		},
		checkResult:function(){
			if(this.status===1){
				var succN = 0;
				for(var i=0;i<this.actList.length;i++){
					var s = this.actList[i].status;
    				if(s==1){
    					succN++;
    				}else if(s==2){
    					this.status=0;
    					this.conf.fail(this.actList[i].errorInfo);
    					return;
    				}
    			}
				if(succN ==this.actList.length){
					this.status=0;
					this.conf.success();
				}
			}
		}
    };
    var Action = function(conf){
    	this.id = conf.id;
    	this.preAct = conf.preAct;
    	this.run = conf.run;/**行动执行*/
    	this.check = conf.check;/**行动检查*/
    	this.monitor;/**行动监控*/
    };
    Action.prototype={
		status:-1,
		errorInfo:"",
		setMonitor:function(monitor){
			this.monitor = monitor;
		},
		finish:function(status,errorInfo){
			this.status = status;
			this.errorInfo = errorInfo||'';
			this.monitor.checkResult();
			if(this.status==1){
				(function(Monitor,preAct){
					for(var i=0;i<Monitor.actList.length;i++){
						if(Monitor.actList[i].preAct===preAct){
							Monitor.actList[i].run();
						}
					}
				})(this.monitor,this.id);
			}
		}
    };
    Monitor.addAct(new Action({"id":"1","check":function(){
    	var e = checkInfo("submit");
    	if(e.err_no!=0){
    		return e.err_info.join("<br>");
    	}else{
    		e = setNextBtn();
    		if(e.err_no!=0){
        		return e.err_info;
        	}
    	}
    	return "";
    },"run":function(){
    	var THIS = this;
    	$$.ajax({
			url: '/updateClientInfo.do?rnd=' + new Date().getTime(),
			type: 'POST',
			data: {
				"name"         : encodeURI(APP_collect.name),
                "code"         : APP_collect.code,
                "ceraddr"      : encodeURI(APP_collect.ceraddr),
                "issued_depart"  : encodeURI(APP_collect.issued_depart),
                "id_begindate"   : APP_collect.id_begindate,
                "id_enddate"     : APP_collect.id_enddate,
                "cidLongTerm"    : APP_collect.cidLongTerm,
				"minzu_code"	 : APP_collect.minzu_code,
				"business_flag"  : APP_collect.business_flag
			},
			timeout: 15000,
			success: function (d) {
				data = JSON.parse(d);
				if (data.errorNo === 0) {
					THIS.finish(1);
				} else if (data.errorNo == 2){
					if(data.userMaxAge){
						THIS.finish(2,"请检查身份证号码是否正确 ，系统判断您的年龄大于" +data.userMaxAge+"周岁，根据规定不允许进行网上开户，请至营业部柜台办理，谢谢！");
					} else {
						THIS.finish(2,data.errorInfo);
					}
				} else if (data.errorNo == 3){
					if(data.userMinAge){
						THIS.finish(2,"请检查身份证号码是否正确 ，系统判断您的年龄小于" +data.userMinAge+"周岁，根据规定不允许进行网上开户，请至营业部柜台办理，谢谢！" );
					} else {
						THIS.finish(2,data.errorInfo);
					}
				} else {
					THIS.finish(2,data.errorInfo);
				}
			},
			error: function() {
				THIS.finish(2,MESSAGE_TIMEOUT);
	   		},
	   		timeout: function() {
	   			THIS.finish(2,MESSAGE_TIMEOUT);
	   		}
		});
    }}));
    
    Monitor.addAct(new Action({"id":"4","preAct":"3","run":function(){
    	var THIS = this;
    	THIS.status = 0;
    	$$.ajax({
			url: '/photoSubmit.do?rnd=' + new Date().getTime(),
			type: 'POST',
			timeout: 15000,
			data: {
				"imageBaseFront" : APP_collect.imageBaseFront,
                "imageBaseBack"  : APP_collect.imageBaseBack,
                "needLocalOcr"   : "2"
			},
			success: function (data1) {
				var data = JSON.parse(data1);
                var status = data.errorNo===0?1:2;
                THIS.finish(status,data.errorInfo);
                if(status==1){
                	stepSync("Sendpic");
                }
			},
			error: function() {
				THIS.finish(2,MESSAGE_TIMEOUT);
	   		},
	   		timeout: function() {
	   			THIS.finish(2,MESSAGE_TIMEOUT);
	   		}
		});
    }}));
    Monitor.addAct(new Action({"id":"2","preAct":"1","run":function(){
    	var THIS = this;
    	THIS.status = 0;
    	$$.ajax({
            url: '/profileRevenue/commitUserProfileRevenue.do?rnd=' + new Date().getTime(),
            method:"POST",
            timeout:15000,
            data:{revenue_inmate_type: "1"},
            success: function(data1){
                var data = JSON.parse(data1);
                var status = data.errorNo===0?1:2;
                THIS.finish(status,data.errorInfo);
                if(status==1){
                	stepSync("Revenue");
                }
            },
            error: function(){
            	THIS.finish(2,MESSAGE_TIMEOUT);
            },
            timeout: function(){
            	THIS.finish(2,MESSAGE_TIMEOUT);
            }
        });
    }}));
    Monitor.addAct(new Action({"id":"3","preAct":"2","run":function(){
    	var THIS = this;
    	APP_collect.signValue="";
    	APP_collect.protocalElem = $$(".agree-block a");
        APP_collect.protocalElemLength = APP_collect.protocalElem.length;//需要签名数量
        for(var i=0; i<APP_collect.protocalElemLength;i++){
            var obj_temp = $$(APP_collect.protocalElem[i]);
            if(APP_collect.signValue == ""){
                APP_collect.signValue += obj_temp.data("id") + ";" + obj_temp.data("md5") + ";" + obj_temp.data("md5");
            }else{
                APP_collect.signValue += "|" + obj_temp.data("id") + ";" + obj_temp.data("md5") + ";" + obj_temp.data("md5");
            }
        }
        $$.ajax({
            url: '/protocalSign.do?rnd=' + new Date().getTime(),
            method: "POST",
            timeout:15000,
            data:  {
                "signValue"    : APP_collect.signValue,
                "cert_sn"      : "NOSN",
				"biz_id"       : "22123"
            },
            success: function(d){
                var data = JSON.parse(d);
                var status = data.errorNo===0?1:2;
                THIS.finish(status,data.errorInfo);
            },
            error: function(){
            	THIS.finish(2,MESSAGE_TIMEOUT);
            },
            timeout: function(){
            	THIS.finish(2,MESSAGE_TIMEOUT);
            }
        });
    }}));
    function alertIdInfo(run){
    	try{
	    	var temp = '<div class="mytext" style="color: #666; text-align:left ">请仔细检查您的身份信息是否正确，如有误请返回修改。</div><div class="list-block confirm-block" ><ul style="background: #f5f5f5">\
	    		<li><div class="item-content"><div class="item-inner"><div class="item-title label modal-item-title">姓名</div>		<div class="item-input modal-item-title">{{name}}</div></div></div></li>\
	            <li><div class="item-content"><div class="item-inner"><div class="item-title label modal-item-title">身份证号码</div>	<div class="item-input modal-item-title">{{code}}</div></div></div></li>\
	            <li><div class="item-content"><div class="item-inner"><div class="item-title label modal-item-title">身份证住址</div>	<div class="item-input modal-item-title"><textarea readonly class="resizeable">{{ceraddr}}</textarea></div></div></div></li>\
	            <li><div class="item-content"><div class="item-inner"><div class="item-title label modal-item-title">签发机关</div>	<div class="item-input modal-item-title"><textarea readonly class="resizeable">{{issued_depart}}</textarea></div></div></div></li>\
	            <li><div class="item-content"><div class="item-inner"><div class="item-title label modal-item-title">有效期限</div>	<div class="item-input modal-item-title">{{id_begindate_show}}-{{id_enddate_show}}</div></div></div></li>\
	            <li><div class="item-content"><div class="item-inner"><div class="item-title label modal-item-title">性别</div>		<div class="item-input modal-item-title">{{sex}}</div></div></div></li>\
	            <li><div class="item-content"><div class="item-inner"><div class="item-title label modal-item-title">民族</div>		<div class="item-input modal-item-title">{{minzu_code}}</div></div></div></li>\
	            <li><div class="item-content"><div class="item-inner"><div class="item-title label modal-item-title">出生日期</div>	<div class="item-input modal-item-title">{{birthday_show}}</div></div></div></li>\
	            </ul></div>';
	    	APP_collect.birthday = $$("input[id=birthTime]").val();
	    	APP_collect.sex = $$("input[id=choosemale]").val();
	    	APP_collect.id_enddate = (APP_collect.cidLongTerm=='1')?"长期有效":APP_collect.id_enddate;
	    	APP_collect.id_begindate_show = APP_collect.id_begindate.replace(/-/g,"/");
	    	APP_collect.id_enddate_show = APP_collect.id_enddate.replace(/-/g,"/");
	    	APP_collect.birthday_show = APP_collect.birthday.replace(/-/g,"/");
	    	var text = Template7.compile(temp)(APP_collect);
	        khApp.modal({
	            title: '信息确认',
	            text: text,
	            buttons: [
	                {text: '<span style="color:#8c8c8c;">返回修改</span>',onClick:function(){
	                	$$("#collectContent").css('overflow','auto');
	                }},
	                {text: '<span style="color:#0A71F0;">确认并提交</span>',onClick:function(){
	                	$$("#collectContent").css('overflow','auto');
	                	run();
	                }}
	            ]
	        });
	        var $model = $$('.mytext').parents('.modal');
	        $model.css('width','90%').css('left','5%').css('margin-left','0');
	        $$("#collectContent").css('overflow','hidden');
    	}catch(e){
    		_CMN.log("collectIdcardController.alertIdInfo error["+(e.stack||e.message||'')+"]");
    		run();
    	}
        try{
        	$$(".resizeable").trigger('change');
        }catch(e){_CMN.log("collectIdcardController.alertIdInfo error2["+(e.stack||e.message||'')+"]");}
    }
    function nextSubmit() {
    	_CMN.log("collectIdcardController.nextSubmit");
    	Monitor.runAct({
    		failCheck:function(errorInfo){
    			khApp.alert(errorInfo);
    		},
    		finishCheck:function(){
    			if(typeof(alertIdInfo)=='function'){
    				alertIdInfo(function(){
        				khApp.showIndicator();
            			$$(".collect-next-button").addClass('disabled');
            			setTimeout(function(){Monitor.run();},200);
        			});
    				return false;
    			}else{
    				khApp.showIndicator();
        			$$(".collect-next-button").addClass('disabled');
        			return true;
    			}
    		},
			success:function(){
				_CMN.log("collectIdcardController.jump["+APP_collect.next+"]");
				khApp.hideIndicator();
				CRHloadPage(APP_collect.next);
        		khApp.closeModal();
			},
			fail:function(errorInfo){
				khApp.hideIndicator();
				$$(".collect-next-button").removeClass('disabled');
				khApp.alert(errorInfo);
			}
		});
	}
	return {
		init: init
	};
});