define(['utils'], function (Utils) {

	 var bindings = [{

    }];


	function init() {
	    window.liveCallback = liveCallback;
	    window.faceDetectCallback = faceDetectCallback;
        faceDetect();
	}

    /**
     * 人脸识别检测方法
     */
	function faceDetect() {
        $$.ajax({
            url: "/getUnidirectionalVideoInfo.do?rnd=" + new Date().getTime(),
            method: "POST",
            success: function (data) {
                data = JSON.parse(data);
                var json = {};
                json.idCardUrl = data.idCardUrl; // 身份证地址
                //json.idCardUrl = "http://58.246.146.133/wangwei.jpg"; // 身份证地址
                json.uploadVideoUrl = data.uploadVideoUrl; // 视频上传地址；
                json.ipAddress =  data.faceVerifyServer; // 人脸识别服务
                json.cookieDomain = data.cookieDomain;

                json.thresholdValue = data.threshold; // 人脸识别分值
                // 授权吗
                json.authCodeString = data.authCodeString;
                json.appid = data.appid; // 授权信息
                json.appSecret = data.appSecret; // 授权码

                json.livessNumber = data.livessNumber; // 活体检测个数
                json.videoMsg = "本人"+data.userName+"自愿在财富证券开户"; // 话术
                json.mPicType = ""; // 暂时无用
                json.recordtime = data.recordtime; // 录制时间
                json.policeVerifyUrl = ""; // 公安认证地址
                json.imageBase = data.imageBase;
                json.cookiestr = data.cookiestr;
                json.liveCallback = "liveCallback"; // 活体检测保存结果回调
                json.faceDetectCallback = "faceDetectCallback"; // 人脸识别结果回调
                if(browser.versions.ios){	//iphone
                    CRHClientbBrowser.loadObjURL("objc://faceDetect/$?"+JSON.stringify(json));
                }else{
                    window.jtoJHandle.faceDetect(JSON.stringify(json));
                }
            },
            error: function () {
                khApp.alert(MESSAGE_TIMEOUT);
            },
            timeout: function () {
                khApp.alert(MESSAGE_TIMEOUT);
            }
        });
    }
// 人脸识别结果回调
    function faceDetectCallback() {
        CRHloadPage('/audit');
    }
// 活体检测保存结果回调
    function liveCallback(json) {
	    console.info(json);
	    var data = JSON.parse(json);
	    console.info(data);
        $$.ajax({
            url: "/livingBodyDetect.do?rnd=" + new Date().getTime(),
            method: "POST",
            data: {
                error_no : data.error_no,
                error_info: data.error_info
            },
            success: function () {

            },
            error: function () {
                khApp.alert(MESSAGE_TIMEOUT);
            },
            timeout: function () {
                khApp.alert(MESSAGE_TIMEOUT);
            }
        });
    }
	return {
		init: init
	};
});
