define(['utils','text!popup/iframe.html'], function (Utils,IFrame) {

    var APP_audit = {};
    APP_audit.title = "";
    APP_audit.content = "";
    APP_audit.tagUrl = "";
    APP_audit.picUrl = "";
    APP_audit.activityDetailsUrl = "";

    APP_audit.tg_broker = "";
    APP_audit.tg_phone = "";
    APP_audit.tg_name = "";
    APP_audit.tg_saleNo = "";
    APP_audit.tg_idCard = "";
    APP_audit.tg_riskLevel = "";
    APP_audit.touguUrl = "";
    APP_audit.idCardExpired = "";//身份证是否过期
    
    var auditData;
	var sz_sta = 0;
    var sh_sta = 0;

    var zd_sz_sta = 0;
    var zd_sh_sta = 0;
    var list=[];

	var bindings = [{
		element: '.current-progress',
		event: 'click',
		handler: progressLookAt
	},{
		element: '#openResultContent .button-fill',
		event: 'click',
		handler: function(){
			if(list[0].txt.indexOf("拒绝开户")>-1){
				var txt =  list[0].txt.split("：");
				khApp.alert(txt[1]);
				return;
			}
			if(APP_audit.idCardExpired == true) {
				khApp.showIndicator();
				$$.ajax({
					url: '/smsForRemindUserToCounterBindBank.do?rnd=' + new Date().getTime(),
					method: "POST",
					timeout:15000,
					success: function(d){
						var data = JSON.parse(d);
						khApp.hideIndicator();
						if(data.errorNo == "0") {
							khApp.alert("您留存在我公司的身份证已经过期，请您前往营业部现场办理。财富证券全国统一客服热线95317热忱为您服务。");
						}
					},
					error: function(){
						khApp.hideIndicator();
						$$(".account-next-button").removeClass('disabled');
						khApp.alert(MESSAGE_TIMEOUT);
					},
					timeout: function(){
						khApp.hideIndicator();
						$$(".account-next-button").removeClass('disabled');
						khApp.alert(MESSAGE_TIMEOUT);
					}
				});
			}else{
				appParams.redo=true;
				mainView.loadPage(this.attributes.tourl.value);
			}
		}
	},{
		element: '#downloadApp',
		event: 'click',
		handler: downloadApp
	},{
		element: '#downloadLZApp',
		event: 'click',
		handler: function () {
			var url = $$("#idAppLeZhuanUrl").val();
			if (browser.versions.ios) {
				window.location.href = "objc://updateApp/$?" + url;
			} else {
				jtoJHandle.updateApp('3', url);
			}
		}
	},{
		element: '#fresh',
		event: 'click',
		handler: fresh
	},{element:'.cfzq-linkj',event:'click',handler:function(){
		var u = 'https://www.cfzq.com';
		if(APP_audit.openWebView!="1"){openIFrame(u);}else{openWebView(u);}
	}},{
		element: '.wechatgo',
		event: 'click',
		handler: wechatgo
	}];
  
	function wechatgo(){
		try{
			if (browser.versions.ios) {
				CRHClientbBrowser.loadObjURL("objc://openWXstatus/?" + APP_audit.mobile);
	        } else {
	        	window.jtoJHandle.openSdAction({"mobile":APP_audit.mobile});
	        }
	        _CMN.log("openResultController.wechatgo");
		}catch(e){_CMN.log("openResultController.wechatgo error["+(e.stack||e.message||'')+"]");}
	}
    function fresh(){
    	if(!APP_audit.freshing){
    		APP_audit.freshing=true;
    		khApp.showIndicator();
    		CRHloadPage('/audit');
    	}
    }
    function downloadApp(){
        var url = $$("#idAppUrl").val();
        if (browser.versions.ios) {
            window.location.href = "objc://updateApp/$?" + url;
        } else {
            jtoJHandle.updateApp('3', url);
        }
    }
	function progressLookAt(){
		mainView.loadPage('/template-3.0/popup/audit-info.html');
	}
	function initimg(){
		try{
			var a = SERVICE_DOMAIN_URL||(/http[s]?:\/\/([^\/]+)\//i.exec(window.location.href)[0]);
			if(a){
				if(a.indexOf('sjkh.cfzq.com')==-1){
					$$("div.result-icon.result-bar-bot").css("background-image",'url("'+a+'/template-3.0/img/resl-icon-w.png")');
					$$("div.result-icon.result-bar-top.active").css("background-image",'url("'+a+'/template-3.0/img/resl-icon-a.png")');
				}
			}
		}catch(e){}
	}
	function init() {
		appParams.redo=false;
		var show_tougu = $$("#show_tougu").val();
		if(show_tougu != 1){
			$$("#goTougu").hide();
		}
		khApp.showIndicator();
		$$.ajax({
          url: '/getAudit.do?rnd=' + new Date().getTime(),
          type: 'POST',
          success: function (d) {
        	  khApp.hideIndicator();
              var data = JSON.parse(d);
              if (data.errorNo == 0) {
                  var models={};
                  var model = [];
                  APP_audit.mobile = data.mobile;
                  APP_audit.title = data.title;
                  APP_audit.content = data.content;
                  APP_audit.tagUrl = data.tagUrl;
                  APP_audit.picUrl = data.picUrl;

                  //投顾信息
                  APP_audit.tg_broker = data.tg_broker;
                  APP_audit.tg_phone = data.tg_phone;
                  APP_audit.tg_name = data.tg_name;
                  APP_audit.tg_saleNo = data.tg_saleNo;
                  APP_audit.tg_idCard = data.tg_idCard;
                  APP_audit.tg_riskLevel = data.tg_riskLevel;
                  APP_audit.touguUrl =  data.touguUrl;

                  APP_audit.activityDetailsUrl = data.activityDetailsUrl;

                  model.push({key:"客户姓名",val:data.accountInfoMap.userName});
                  model.push({key:"资金账户",val:data.accountInfoMap.fund_account_status=="1"&&data.accountInfoMap.fund_account?data.accountInfoMap.fund_account:"受理中"});
                  model.push({key:"上海A股",val:data.accountInfoMap.stockAccountSHFlag=="1"&&data.accountInfoMap.stockAccountSH?data.accountInfoMap.stockAccountSH:data.accountInfoMap.stockAccountSH_msg});
                  model.push({key:"深圳A股",val:data.accountInfoMap.stockAccountSZFlag=="1"&&data.accountInfoMap.stockAccountSZ?data.accountInfoMap.stockAccountSZ:data.accountInfoMap.stockAccountSZ_msg});
                  models.only1003 = false;

                  var list1002 = data.accountInfoMap.stock_account;
                  if(list1002&&list1002.length>0){
                      for(var i=0;i<list1002.length;i++){
                    	  var acc = list1002[i];
                          if(acc.account_name == "上海场内基金"){
                              model.push({key:acc.account_name,val:(acc.open_status=="1"&&acc.stock_account)?acc.stock_account:acc.open_result});
                              sh_sta = 1;
                          }
                          if(acc.account_name == "深圳场内基金"){
                              model.push({key:acc.account_name,val:(acc.open_status=="1"&&acc.stock_account)?acc.stock_account:acc.open_result});
                              sz_sta = 1;
                          }
                      }
                  }
                  if(sh_sta == 0){
                      model.push({key:"上海场内基金",val:"未申请"});
                  }
                  if(sz_sta == 0){
                      model.push({key:"深圳场内基金",val:"未申请"});
                  }

                  var list1003 = data.accountInfoMap.ofstock_account;
                  if(list1003&&list1003.length>0){
                      for(var i=0;i<list1003.length;i++){
                    	  var acc = list1003[i];
                          if(acc.fund_company == "中登上海" ||acc.fund_company == "中登深圳"){
                              model.push({key:acc.fund_company,val:(acc.open_status=="1"&&acc.stock_account)?acc.stock_account:acc.open_result});
                              if(acc.fund_company == "中登上海"){
                                  zd_sh_sta = 1;
                              }else{
                            	  zd_sz_sta = 1;
                              }
                          }
                      }
                      if(!list1002||list1002.length==0){
                    	  models.only1003 = true;
                      }
                  }
                  if(zd_sh_sta == 0){
                      model.push({key:"中登上海",val:"未申请"});
                  }
                  if(zd_sz_sta == 0){
                      model.push({key:"中登深圳",val:"未申请"});
                  }


                  model.push({key:"三方存管",val:data.accountInfoMap.bank_name});
                  if(data.open_new_account==1){
                      model.push({key:"三方存管",val:data.accountInfoMap.bank_name});
                  }
                  models.accountInfo=model;
                  if(data.open_new_account==1){
                      models.showNewAccount=true;
                  }
                  //判断是否开户成功
                  if(data.accountInfoMap.fund_account_status=="1"&&data.accountInfoMap.fund_account){
                      models.result=1;
                  } else if(data.resultList.list.length > 0){
                      models.result= 2;
                      models.resultList = data.resultList.list;
                      APP_audit.idCardExpired = data.resultList.idCardExpired;
                      list = data.resultList.list;

                  } else {
                      stepSync("OpenAccountApply");
                      models.result= 0;
                  }
                  if(data.channelself == 1){
                      models.channelself=true;
                  }else{
                      models.channelself=false;
                  }
                  models.befromFlag = befromFlag;
                  models.open_type = appParams.open_type;
                  
                  var submit_next_transday = data.accountInfoMap.submit_next_transday; //8位年月日
                  // 预计开户成功日期
                  models.expecteOpendate = submit_next_transday.substring(0,4)+"年"+submit_next_transday.substring(4,6)+"月"+submit_next_transday.substring(6,8)+"日";
                  // 开户成功日期
                  var success_date = data.accountInfoMap.success_date;
                  models.success_date = success_date.substring(0,4)+"年"+success_date.substring(4,6)+"月"+success_date.substring(6,8)+"日";
                  // 开户成功后下一交易日
                  var success_next_transday = data.accountInfoMap.success_next_transday;
                  models.success_next_transday = success_next_transday.substring(0,4)+"年"+success_next_transday.substring(4,6)+"月"+success_next_transday.substring(6,8)+"日";
                  // 文案配置
                  models.curr_operation = data.curr_operation;
                  models.next_operation = data.next_operation;
                  if(models.result==0||models.result==1){
                	  models.showDownloadAppBtn = data.showDownloadAppBtn;
                	  models.showWechatgo = data.showWechatgo;
                  }
                  render({
                      bindings: bindings,
                      model: models,
                      data:data
                  });

            	  initimg();
                  // 拒绝开户文案展示
                  for(var i=0;i<list.length;i++){
                	  if(list[i].refuse && list[i].refuse=="true"){
                		  $$(".error-reason-block").html("");
                		  $$("#openResultContent .button-fill").hide();
                		  var refuseText = list[i].txt.replace(/拒绝开户：/g,"");
                		  $$(".error-reason-block").html(refuseText);
                		  break;
                	  }
                  }
                  
                  models.protocals = data.signList;
                  auditData = models;
                  if(data.activity == "0"){
                      $$(".event").hide();
                  }
                  var show_tougu = $$("#show_tougu").val();
                  if(show_tougu != 1){
                      $$("#goTougu").hide();
                  }
                  APP_audit.openWebView = data.openWebView;
                  
                  setTimeout(function(){
                	if($$(".audit-content").length==0){
                    	_CMN.log("500ms前,开户结果页渲染失败,");fresh();
                    }else{
                  	  _CMN.log("500ms前,开户结果页渲染成功");
                    }
                  },500);
                  APP_audit.freshing=false;
              }else{
                  khApp.alert(data.errorInfo);
              }
          }
      });
	}

    function swiperInit(data){
    	var arr= data.imageMap;
    	$$(".swiper-wrapper").html("");
    	if(arr.length<1){
    		$$('.swiper-container').hide();
    		return;
    	}
    	$$('.swiper-container').show();
        var str = "";
        var lbtimes = "";
        for(var i =0;i<arr.length;i++){
            str += "<div class='swiper-slide'>"+
                "<a class='external' href='#'>"+
                "<img class='ad-img' data-image_url='"+arr[i].image_url+"' src='data:image/.jpg;base64,"+arr[i].image_data+"' style='width:100%;display:block'>"+
                "</a>"+
                "</div>";
            lbtimes = arr[i].times || 5000;
        };
        $$('.swiper-wrapper').append(str);

        var mySwiperSlow = khApp.swiper('.swiper-container', {
            pagination:'.swiper-container .swiper-pagination',
            autoplay:lbtimes,
            speed: 600,
            loop: true,
            autoplayDisableOnInteraction : false
        });

        $$(".ad-img").on("touchstart", function () {
            var image_url = $$(this).data("image_url");
            if(image_url && image_url != " "){
                if( APP_audit.openWebView != "1"){
                    openIFrame($$(this).data("image_url"));
                }else{
                    openWebView($$(this).data("image_url"));
                }
            }

        });
    }

    /**
     * 打开广告
     */
    function openIFrame(src) {
        var iframe = document.createElement('iframe');
        var compiledTemplate = Template7.compile(IFrame);
        var model = {};
        model.webUrl = SERVICE_DOMAIN_URL;
        var renderTemplate = compiledTemplate({model: model});
        $$('.popup').html('').append(renderTemplate);
        $$('.popup #iframe').append(iframe);
        iframe.src = src;
        iframe.width = '100%';
        iframe.height = '100%';
        iframe.id = 'myIframe';
        khApp.popup('.popup');
        $$("#returnVideo").on("click", function () {
            khApp.closeModal();
        });
    }

    var t_img; // 定时器
    var isLoad = true; // 控制变量

    function isImgLoad(callback){
        $$('img').each(function(){
            if(this.height === 0){
                isLoad = false;
                return false;
            }
        });
        if(isLoad){
            clearTimeout(t_img);
            callback();
        }else{
            isLoad = true;
            t_img = setTimeout(function(){
                isImgLoad(callback);
            },500);
        }
    }
	function render(params) {
		var template = $$('#openResultTemplate').html();
		var compiledTemplate = Template7.compile(template);
		var renderTemplate = compiledTemplate({model: params.model,SERVICE_DOMAIN_URL:SERVICE_DOMAIN_URL||""});
		$$('#openResultContent').html(renderTemplate);
		Utils.bindEvents(params.bindings);
		swiperInit(params.data);
		isImgLoad(function(){
			positionReset();
		});
	}
	function positionReset(){
		try{
			var parentHeight = 0;
			var childsHeight = 0;
			var result = -1;
			var $parent = $$('.page-content');
			if($parent.length>0){
				parentHeight = $parent.outerHeight();
				var childs = $parent[0].children;
				if(childs.length>=2){
					var $lastChild = $$(childs[childs.length-1]);
					if($lastChild.hasClass('bottom-content')){
						var $preChild = $$(childs[childs.length-2]);
						childsHeight = $lastChild.outerHeight()+$preChild.outerHeight()+$preChild.offset().top;
						var v = parentHeight - childsHeight;
						if(v<0){
							$lastChild.css({position:'static'});result=1;
						}else if(v<=35){
							$lastChild.css('margin-top','35px');result=2;
						}else{
							$lastChild.css({position:'absolute',bottom:'0'});result=3;
						}
					}
				}
			}
			_CMN.log("openResultController.positionReset[parentHeight="+parentHeight+"][childsHeight="+childsHeight+"][result="+result+"]");
		}catch(e){
			_CMN.log("openResultController.positionReset error["+(e.stack||e.message||'')+"]");
		}
    }
	return {init:init};
});