define(['utils','GS'],function(Utils,GS){
	'use strice';
    var APP_risk={};
    APP_risk.bindings=[{
    	element:'.risk-next-button',event:'click',handler:nextSubmit
    },{
    	element:'input[name="agreement"]',event:'change',handler:agreementClick
	},{
		element:'.clickProtocal',event:'click',handler:function(){
			mainView.loadPage("/template-3.0/protocal.html?econtract_id=" + $$(this).data("id"));
		}
	},{
		element:'.retest',event:'click',handler:function(){
			mainView.loadPage('exam?fnf=nextPass');
		}
	},{
		element:'.risk-logout',event:'click',handler:GS.logout
	}];

	function init(){
		khApp.showIndicator();
		$$.ajax({
			url:'/getRiskResult.do?v='+new Date().getTime(),
			type:'POST',
			success:function(d){
				var data = JSON.parse(d);
				if (data.errorNo===0){
					data.riskResult.openType = appParams.open_type;
					data.paper_score = parseInt(data.riskResult.paper_score);
					renderResult({model:data,bindings:APP_risk.bindings});
					_CMN.log("riskResultController init finish");
				}else{
					khApp.alert(data.errorInfo);
				}
				khApp.hideIndicator();
			},
			error:function(){khApp.hideIndicator();khApp.alert(MESSAGE_TIMEOUT);},
			timeout:function(){khApp.hideIndicator();khApp.alert(MESSAGE_TIMEOUT);}
		});
	}
	function renderResult(params){
    	params.activebreak=!(params.model.riskResult.corp_risk_level!='0'||appParams.open_type=="5");
    	var compiledTemplate = Template7.compile($$('#riskResultTemplate').html());
    	var renderTemplate = compiledTemplate({model:params});
    	$$('#riskResultContent').html(renderTemplate);
    	Utils.bindEvents(params.bindings);
    	if(!params.activebreak){
    		getValue(params.model.riskResult.corp_risk_level);
    	}
	}
	function getValue(l){
		setTimeout(function(){
			var index=0;
			try{
				if(l){index=parseInt(l)-1;}
			}catch(e){}
			$$('.progress-bg').css('width',((index+1)*20)+'%');
			for(var i=0;i<=index;i++){
				$$('.score-progress li').eq(i).find('p').css('color','#fff');
			}
		},500);
	}
	function agreementClick(e){
		e.stopPropagation();
		setTimeout(function(){
			if($$("input[name='agreement']").prop('checked')){
				$$('.button-fill').removeClass('disabled');
			}else{
				$$('.button-fill').addClass('disabled');
			}
		},100);
	}
    function nextSubmit(){
        khApp.showIndicator();
        $$(".risk-next-button").addClass('disabled');
        var $agree = $$(".agree-block a");
        var signValue=[];
        for(var i=0; i<$agree.length;i++){
            var p = $$($agree[i]);
            signValue.push(p.data("id")+";"+p.data("md5")+";"+p.data("md5"));
        }
        $$.ajax({
            url:'/protocalSign.do?rnd=' + new Date().getTime(),
            method:"POST",
            timeout:15000,
            data:{
                "signValue"    : signValue.join("|"),
                "cert_sn"      : "NOSN",
                "risk_notice"  : "1",
				"biz_id"       : "10084"
            },
            success:function(d){
                khApp.hideIndicator();
                var data = JSON.parse(d);
                if(data.errorNo === 0){
                    stepSync("TestResult");
                    CRHloadPage(data.nextPage||"/openaccount");
                }else{
                    $$(".risk-next-button").removeClass('disabled');
                    khApp.alert(data.errorInfo);
                }
            },
            error: function(){
                khApp.hideIndicator();
                $$(".risk-next-button").removeClass('disabled');
                khApp.alert(MESSAGE_TIMEOUT);
            },
            timeout: function(){
                khApp.hideIndicator();
                $$(".risk-next-button").removeClass('disabled');
                khApp.alert(MESSAGE_TIMEOUT);
            }
        });
	}
	return {
		init:init
	};
});