define(['services/openTypeService'], function (OTS) {

    // 初始页
    var startPage = OTS.setStartPage();

  //注销不弹出确认框
	function logoutWithoutPrompt() {
	    if (browser.versions.YiXin) {
	        khApp.closePanel();
		    YixinJSBridge.call('closeWebView');
	        return;
	    }
        else if (browser.versions.ios) {	//iphone
            window.location.href = 'objc://callIOSQuit/';
        } else if (browser.versions.android) {
            jtoJHandle.removeCookie();
        }
		khApp.showIndicator();
        var currentPage = $$('.page-on-center').data('page');
        if (currentPage === 'video') {
            // do something...
        	APP_video.needWait 		= false;	//不在查询
        	$$.ajax({
				method: "POST",
				data: {},
				url: "/videoQuitQueue.do?rnd=" + new Date().getTime(),
				success:function(data){
					var data = JSON.parse(data);
					console.log("退出:"+data.errorNo);
				},
				error: function(){
					khApp.hideIndicator();
		   			khApp.alert(MESSAGE_TIMEOUT);
		   		},
		   		timeout: function(){
		   			khApp.hideIndicator();
					khApp.alert(MESSAGE_TIMEOUT);
		   		}
			});
        }else if(currentPage === 'cert'){
        	APP_cert.needWait = false;
        }
     
        khApp.closePanel();
        CRHloadPage(startPage);
	
	}
	
	//注销
	function logout() {
		khApp.confirm('您确定要退出登录吗？', function () {
		    if (browser.versions.YiXin) {
		        khApp.closePanel();
			    YixinJSBridge.call('closeWebView');
		        return;
		    }
            if(appParams.clientTip == "1"){
                exitKaihu();
			}else{
				if (browser.versions.ios) {	//iphone
					window.location.href = 'objc://callIOSClearCookie/';
					window.location.href = 'objc://callIOSQuit/';
				} else if (browser.versions.android) {
					if(befromFlag == "sjkh-default"){
                        window.jtoJHandle.removeCookie();
					}else{
						window.jtoJHandle.closeSJKH();
					}
				}
			}
			$$.ajax({
				method: "POST",
				data: {},
				url: "/quitKh.do?rnd=" + new Date().getTime(),
				success:function(data){
					var data = JSON.parse(data);
					console.log("退出:"+data.errorNo);
                    khApp.closePanel();
                    CRHloadPage(startPage);
				},
				error: function(){
					khApp.alert(MESSAGE_TIMEOUT);
				},
				timeout: function(){
					khApp.alert(MESSAGE_TIMEOUT);
				}
			});
			khApp.showIndicator();
            var currentPage = $$('.page-on-center').data('page');
            if (currentPage === 'video') {
                // do something...
            	APP_video.needWait 		= false;	//不在查询
            	$$.ajax({
					method: "POST",
					data: {},
					url: "/videoQuitQueue.do?rnd=" + new Date().getTime(),
					success:function(data){
						var data = JSON.parse(data);
						console.log("退出:"+data.errorNo);
					},
					error: function(){
						khApp.hideIndicator();
			   			khApp.alert(MESSAGE_TIMEOUT);
			   		},
			   		timeout: function(){
			   			khApp.hideIndicator();
						khApp.alert(MESSAGE_TIMEOUT);
			   		}
				});
            }else if(currentPage === 'cert'){
            	APP_cert.needWait = false;
            }
         

		});
	}

    // 检查版本
    function checkUpdate() {
        khApp.modal({
            title: '当前版本',
            text: window.appParams.version,
            buttons: [{
                text: '检测更新',
                onClick: function () {
                    khApp.alert('您当前的版本已经是最新');
                }
            }, {
                text: '返回'
            }]
        });
    }
    
    function clearCache(){
    	khApp.modal({
            title: '缓存管理',
            text: '确定要清理缓存并重新登陆吗？<br>清理缓存后请关掉此应用程序后台进程然后重新打开此应用！',
            buttons: [{
                text: '缓存清理',
                onClick: function () {
                	if(appParams.clientTip == "1"){
                		exitKaihu();
					}else{
                        if (browser.versions.ios) {	//iphone
                            window.location.href = 'objc://callIOSClearCookie/';
                        } else if (browser.versions.android) {
                            jtoJHandle.removeCookie();
                            khApp.alert("Android系统，请到手机设置中软件管理中清除本应用的缓存文件");
                        }
					}

                    khApp.closeModal();
            		khApp.closePanel();
            		CRHloadPage(OTS.setStartPage());
                }
            }, {
                text: '取消'
            }]
        });
    }
    function quickDial(p){
    	try{
			p=p||"95317";
			if(_CMN.isTHS()){
	            window.location.href="tel:" +p;
			}else{
	            if(browser.versions.ios){
	            	CRHClientbBrowser.loadObjURL("objc://quickDial/?" +p);
	            } else {
	                jtoJHandle.quickDial(p);
	            }
			}
    	}catch(e){_CMN.log("GS.quickDial err:["+(e.stack||e.message||'')+"]");}
	}
	return {
		logout: logout,
        startPage: startPage,
        checkUpdate: checkUpdate,
        clearCache: clearCache,
        logoutWithoutPrompt:logoutWithoutPrompt,
        quickDial:quickDial
	};
});
