define(['utils'], function (Utils) {

	function render(params) {
		Utils.bindEvents(params.bindings);
	}

	function showPhotoFront(url) {
		$$('#cardFront').html('<img src=' + url + ' alt="" height="160">');
	}

	function showPhotoBack(url) {
		$$('#cardBack').html('<img src=' + url + ' alt="" height="160">');
	}

	function showPhotoFace(url) {
		$$('#faceImg img').attr('src',url);
	}

	return {
		render: render,
		showPhotoFront: showPhotoFront,
		showPhotoBack: showPhotoBack,
		showPhotoFace: showPhotoFace
	};
});
