define( [ 'utils' ], function(Utils) {

	function render(params) {
		Utils.bindEvents(params.bindings);
	}

	function showPhotoFace(url) {
		//$$('.realpic img').attr("src",url);
		$$("#realpic1").html('<img src="'+url+'" height="98" alt="">');
		hidePic();
		hideReady("photo");
	}
	function showVideoPhoto(base64) {
		$$("#realpic2").html('<img src="data:image/jpg;base64,'+base64+'" height="98" alt="">');
		hideVideo();
		hideReady("video");
	}
	function showReady(type) {
		$$('#' + type + 'ReadyText').show();
		$$('#' + type + 'DoneText').hide();
	}

	function hideReady(type) {
		$$('#' + type + 'ReadyText').hide();
		$$('#' + type + 'DoneText').show();
	}

	function showPic() {
		$$('#photoReady').show();
		$$('#realpic1').hide();
	}

	function hidePic() {
		$$('#photoReady').hide();
		$$('#realpic1').show();
	}

	function hideVideo() {
		$$('#videoReady').hide();
		$$('#realpic2').show();

	}

	return {
		render : render,
		showPhotoFace : showPhotoFace,
		showVideoPhoto  :showVideoPhoto,
		showReady: showReady,
	    hideReady: hideReady,
	    showPic: showPic,
	    hidePic: hidePic,
	    hideVideo: hideVideo
	};
});
